********************************************************************************
* ɽ ϵήϳ ׻¸
*
*     γҳȻ
*     ֥饦ưˤ¿γҷγȻ
*
*  99/04/24  
*      99/05/11 ; 
********************************************************************************
      program brown2

      parameter(nmax=3000,itmax=200)  ! nmax: γҿ, itmax: ֤׻ 
      parameter(dt=0.1)               ! dt: ֹ
      parameter(jbox=40)              ! jbox: ҥȥΥܥå
      parameter(xmin=-5.0,xmax=5.0,ymin=-5.0,ymax=5.0)  ! ɥϰ

      real x(0:itmax,nmax), pdfx(jbox,0:itmax)
      real y(0:itmax,nmax), pdfy(jbox,0:itmax)
      character cdummy*60
*-----+--1---------2---------3---------4---------5---------6---------7-+
* ¸ѥ᡼ɤ߹
      open(1,file='expar2.data')
      read(1,*) a0,      ! ﳰϤ礭
     +          a1,      ! Ϥ礭(졼꡼໤η)
     +          b,       ! ȥƥåϤ礭
     +          iseed,   ! (RANDLIB)Ѥμ: iseed .ne. 0
     +          istep,   ! սϤΥƥå״ֳ
     +          cdummy
      close(1)

* 
      call initia(x, y, iseed)
* ȯŸ
      call timein(x, y, a0, a1, b, iseed, dt)
* ʬ۴ؿ
      call xypdf (x, y, pdfx, pdfy, istep)
* 
      call graph (x, y, pdfx, pdfy, istep, dt)

      stop
      end
********************************************************************************
      subroutine initia(x, y, iseed)

* γҤν֤, ѤȾrα˰Ū

      parameter(nmax=3000,itmax=200)  ! nmax: γҿ, itmax: ֤׻ 

      real x(0:itmax,nmax), y(0:itmax,nmax)
*-----+--1---------2---------3---------4---------5---------6---------7-+
      r = 0.2
      do n=1,nmax
   99   px = r*(2.0*rngu3(iseed) - 1.0)
        py = r*(2.0*rngu3(iseed) - 1.0)
        dd = px**2 + py**2
        if(dd .gt. r**2) then
          go to 99
        end if
        x(0,n) = px
        y(0,n) = py
      end do

      return
      end
********************************************************************************
      subroutine timein(x, y, a0, a1, b, iseed, dt)

* γ˻ȯŸ

      parameter(nmax=3000,itmax=200)  ! nmax: γҿ, itmax: ֤׻ 

      real x(0:itmax,nmax), y(0:itmax,nmax)
*-----+--1---------2---------3---------4---------5---------6---------7-+
      do n=1,nmax
*     γҤν®٤ϥ
        u = 0.0
        v = 0.0
        do i=1,itmax
          call random(srand1, srand2, iseed)
          du =      - a1*u + b*srand1
          dv = - a0 - a1*v + b*srand2
          u  = u + du*dt
          v  = v + dv*dt
          x(i,n) = x(i-1,n) + du*dt
          y(i,n) = y(i-1,n) + dv*dt
        end do
      end do

      return
      end
********************************************************************************
      subroutine random(srand1,srand2,iseed)

* ֥롼
*      μ 
*     ʸ: Numerical Recipes
*-----+--1---------2---------3---------4---------5---------6---------7-+     
   99 v1 = 2.*rngu3(iseed) - 1.
      v2 = 2.*rngu3(iseed) - 1.
      r  = v1**2 + v2**2
      if(r .ge. 1.) goto 99

      factor = sqrt( -2.*log(r)/r )

      srand1 = v1*factor
      srand2 = v2*factor

      return
      end
***********************************************************************
      subroutine xypdf(x, y, pdfx, pdfy, istep)

* ʬ۴ؿη׻

      parameter(nmax=3000,itmax=200)  ! nmax: γҿ, itmax: ֤׻ 
      parameter(jbox=40)              ! jbox: ҥȥΥܥå
      parameter(xmin=-5.0,xmax=5.0,ymin=-5.0,ymax=5.0)  ! ɥϰ

      real x(0:itmax,nmax), pdfx(jbox,0:itmax)
      real y(0:itmax,nmax), pdfy(jbox,0:itmax)
*-----+--1---------2---------3---------4---------5---------6---------7-+
      delx = (xmax-xmin)/jbox
      dely = (ymax-ymin)/jbox

      call rset(pdfx, jbox*(itmax+1), 1, 0.0)
      call rset(pdfy, jbox*(itmax+1), 1, 0.0)

      do i=0,itmax,istep
        do n=1,nmax
          do j=1,jbox
            xl = xmin + delx*(j-1)
            xm = xl   + delx
            if(x(i,n).ge.xl .and. x(i,n).lt.xm) then
              pdfx(j,i) = pdfx(j,i) + 100.0/nmax ! %ɽ
            end if

            yl = ymin + dely*(j-1)
            ym = yl   + dely
            if(y(i,n).ge.yl .and. y(i,n).lt.ym) then
              pdfy(j,i) = pdfy(j,i) + 100.0/nmax ! %ɽ
            end if
          end do
        end do
      end do
  
      return
      end
********************************************************************************
      subroutine graph(x, y, pdfx, pdfy, istep, dt)

* 

      parameter(nmax=3000,itmax=200)  ! nmax: γҿ, itmax: ֤׻ 
      parameter(jbox=40)              ! jbox: ҥȥΥܥå
      parameter(xmin=-5.0,xmax=5.0,ymin=-5.0,ymax=5.0)  ! ɥϰ
      parameter(pmax=12.0)

      real x(0:itmax,nmax), pdfx(jbox,0:itmax)
      real y(0:itmax,nmax), pdfy(jbox,0:itmax)
      character ctime*8
*-----+--1---------2---------3---------4---------5---------6---------7-+
      call glrget('rundef', rundef)
      call swiset('iwidth',  540)
      call swiset('iheight', 540)
      call swlset('lalt',   .true.)
      call swlset('lwait',  .false.)
      call sglset('lcorner',.false.)
      call sglset('lclip',  .true.)

      call gropn(1)

* istep ˳
      do i=0,itmax,istep
        call grfrm
        call grswnd(xmin, xmax, ymin, ymax)
        call grsvpt(0.15, 0.75, 0.15, 0.75)
        call grstrn(1)
        call grstrf

        call uxaxdv('b', 0.5, 2.0)
        call uxaxdv('t', 0.5, 2.0)
        call uyaxdv('l', 0.5, 2.0)
        call uyaxdv('r', 0.5, 2.0)
        call uxmttl('b', 'X', 0.0)
        call uymttl('l', 'Y', 0.0)

* γҷ
        call sgspmi(41)
        do n=1,nmax
          call sgpmu(1, x(i,n), y(i,n))
        end do

* x-ʬ۴ؿ
        call grfig
        call grswnd(xmin, xmax, 0.0 , pmax)
        call grsvpt(0.15, 0.75, 0.77, 0.95)
        call grstrn(1)
        call grstrf

        call uuslni(22)
        call uusidv(xmin, xmax)
        call uvbxl(jbox, rundef, pdfx(1,i))

        call uzlset('labelxb', .false.)
        call uxaxdv('b', 0.5, 2.0)
        call uzlset('labelxb', .true.)
        call uxaxdv('t', 0.5, 2.0)
        call uyaxdv('l', 1.0, 5.0)
        call uyaxdv('r', 1.0, 5.0)
        call uysttl('l', 'PDF(%)', 0.0)

* y-ʬ۴ؿ
        call grfig
        call grswnd(0.0 , pmax, ymin, ymax)
        call grsvpt(0.77, 0.95, 0.15, 0.75)
        call grstrn(1)
        call grstrf

        call uusidv(ymin, ymax)
        call uhbxl(jbox, pdfy(1,i), rundef)

        call uxaxdv('b', 1.0, 5.0)
        call uxaxdv('t', 1.0, 5.0)
        call uzlset('labelyl', .false.)
        call uyaxdv('l', 0.5, 2.0)
        call uzlset('labelyl', .true.)
        call uyaxdv('r', 0.5, 2.0)
        call uxsttl('b', 'PDF(%)', 0.0)

* 
        call grfig
        call grswnd(0.0 , 1.0, 0.0 , 1.0)
        call grsvpt(0.75, 1.0, 0.75, 1.0)
        call grstrn(1)
        call grstrf

        ctime = 'T='
        write(ctime(3:6),'(f4.1)') i*dt
        call sgstxi(2)
        call sgstxs(0.03)
        call sgtxv(0.88, 0.88, ctime)
      end do

      call grcls

      return
      end
********************************************************************************









