********************************************************************************
* ɽ ϵήϳ ׻¸
*
*     ήήβΥ饰󥸥屿ư (4)
*     عԥå  åեå
*
*     Ż߲: ήؿ
*                          
*  99/05/10  ͧ
*      99/05/11 ; 
********************************************************************************
      program lagra4

      parameter(pi=3.141592)
      parameter(xmin=0.,xmax=2*pi,ymin=0.,ymax=xmax/2)
      parameter(nx=101,ny=51)
      parameter(nx1=17,ny1=9)
      parameter(nx2= 5,ny2=3)

      real psi(nx,ny)
      real rxy1(nx1),rxy2(nx2)
      character cdummy*60,csgi*1
      character cxy2(nx2)*4

      common /const/amp, u0

*-----+--1---------2---------3---------4---------5---------6---------7-+
      amp = 1.

c**** experimental parameters ****c
      open(1,file='expar4.data')
      read(1,*) xoffst,      ! եå濴xɸ
     +          yoffst,      ! եå濴yɸ
     +          rlen,        ! եåΰդĹ
     +          u0,      ! طʤΰή®
     +          cdummy

c**** flow field psi(x,y) ****c
      delx = (xmax-xmin)/(nx-1)
      dely = (ymax-ymin)/(ny-1)
      yc   = (ymin+ymax)/2

      do j=1,ny
        do i=1,nx
          xx = xmin + delx*(i-1)
          yy = ynin + dely*(j-1)
          psi(i,j) = amp*sin(xx)*sin(yy) - u0*(yy-yc)
        end do
      end do

c**** graph ****c
      call sglset('lcorner',.false.)
      call sglset('lclip',.true.)
      call sglset('lfull',.true.)
      call udpset('lmsg', .false.)
      call udpset('label',.false.)

c**** setup for uzpack ****c
      axdel1 = (xmax-xmin)/(nx1-1)
      do l=1,nx1
        rxy1(l) = xmin + (l-1)*axdel1
      end do

      axdel2 = (xmax-xmin)/(nx2-1)
      do l=1,nx2
        rxy2(l) = xmin + (l-1)*axdel2
      end do

      cxy2(1) = '0'
      cxy2(2) =        csgi(167) // '/2'
      cxy2(3) =        csgi(167)
      cxy2(4) = '3' // csgi(167) // '/2'
      cxy2(5) = '2' // csgi(167)

      call sgpwsn
      read(*,*) iws
      call gropn(iws)

      call grfrm
      call grswnd(xmin, xmax, ymin, ymax)
      call grsvpt(0.15, 0.95,  0.2,  0.6)
      call grstrn(1)
      call grstrf

      call udgclb(psi, nx, nx, ny, 0.19625)
      call udcntr(psi, nx, nx, ny)

      call uxaxlb('b', rxy1, nx1, rxy2, cxy2, 4, nx2)
      call uxaxdv('t', pi/8., pi/2.) 
      call uxsttl('b', 'X', 0.0)
      call uyaxlb('l', rxy1, ny1, rxy2, cxy2, 4, ny2)
      call uyaxdv('r', pi/8., pi/2.) 
      call uysttl('l', 'Y', 0.0)

      call grcls

      stop
      end
********************************************************************************
