********************************************************************************
* ɽ ϵήϳ ׻¸
*
*     
*     1 x(n+1) = x(n)**2 - c ΥꥢץΥջؿ
*
*  93/xx/yy  ʻ
*      99/07/17 ; 
********************************************************************************
      program ec5

      implicit real*8(d)
      parameter(nmax=5000,mmax=1999)

      dimension rx(mmax), ry(mmax)
*-----+--1---------2---------3---------4---------5---------6---------7-+
      do m=1,mmax
        dc = 1.d-3*m
        dx = 0.5d0
        dy = 0.d0
        rx(m) = dc

        do n=0,nmax-1
          if(dx .eq. 0.d0) go to 99
          dy = dy + log(abs(2*dx))
          dx = dx**2 - dc
        end do
        ry(m) = dy / nmax
        go to 88
   99   ry(m) = -999.
   88   continue
        if(mod(m,100) .eq. 0) write(*,*) m, '/', mmax, ' is over'
      end do

      call grf(mmax, rx, ry)

      stop
      end
*******************************************************************************
      subroutine grf(mmax, x, y)

      parameter(uxmin=0.0,uxmax=2.0,uymin=-2.0,uymax=1.0)
      parameter(axmi=0.1,axma=0.5,aymi=0.1,ayma=1.0)      

      real x(mmax), y(mmax)
*-----+--1---------2---------3---------4---------5---------6---------7-+
      call swiset('iwidth',  720)
      call swiset('iheight', 540)
      call sglset('lfull', .true.)
      call sglset('lclip', .true.)
      call sglset('lcntl', .true.)
      call sglset('lcorner', .false.)
      call uzfact(0.8)

      call gropn(1)
      call grfrm
      call grswnd(uxmin, uxmax, uymin, uymax)
      call grsvpt( 0.10,  0.95,  0.10,  0.65)
      call grstrn(1)
      call grstrf

      call uxaxdv( 'b', axmi,  axma )
      call uxaxdv( 't', axmi,  axma )
      call uyaxdv( 'l', aymi,  ayma )
      call uyaxdv( 'r', aymi,  ayma )
      call sglnu(uxmin, 0., uxmax, 0.)

      call uxsttl( 'b', 'c', 0.0 )
      call uysttl( 'L', 'Lyapunov Exponent', 0.0 )

      call sgspms(0.01)
      do m=1,mmax
        if(y(m) .gt. 0.) then
          call sgspmi(23)
        else
          call sgspmi(43)
        end if
        call sgpmu(1, x(m), y(m))
      end do

      call grcls

      return
      end
********************************************************************************





  
