*################ graph.f

      real t11(1001),y1(1001),x11(1001),x12(1001),t12(1001)
      real t21(1001),y2(1001),x21(1001),x22(1001),t22(1001)
      real t31(1001),y3(1001),x31(1001),x32(1001),t32(1001)
      real t41(1001),y4(1001),x41(1001),x42(1001),t42(1001)
      real t43(1001),x43(1001)

      open(unit=12,iostat=ios,err=100,
     /     file='ozone0.dat',
     /     status='old',access=
     /     'sequential',form='formatted')
      read(unit=12,fmt=200,iostat=ios,err=300)
     /     t11
      
      open(unit=12,iostat=ios,err=100,
     /     file='ozone0-co2.dat',
     /     status='old',access=
     /     'sequential',form='formatted')
      read(unit=12,fmt=200,iostat=ios,err=300)
     /     t12

      open(unit=12,iostat=ios,err=100,
     /     file='prime.dat',
     /     status='old',access=
     /     'sequential',form='formatted')
      read(unit=12,fmt=200,iostat=ios,err=300)
     /     t21
      
      open(unit=12,iostat=ios,err=100,
     /     file='co2.dat',
     /     status='old',access=
     /     'sequential',form='formatted')
      read(unit=12,fmt=200,iostat=ios,err=300)
     /     t22

      open(unit=12,iostat=ios,err=100,
     /     file='prime.dat',
     /     status='old',access=
     /     'sequential',form='formatted')
      read(unit=12,fmt=200,iostat=ios,err=300)
     /     t31
      
      open(unit=12,iostat=ios,err=100,
     /     file='ozone.dat',
     /     status='old',access=
     /     'sequential',form='formatted')
      read(unit=12,fmt=200,iostat=ios,err=300)
     /     t32

      open(unit=12,iostat=ios,err=100,
     /     file='prime.dat',
     /     status='old',access=
     /     'sequential',form='formatted')
      read(unit=12,fmt=200,iostat=ios,err=300)
     /     t41
      
      open(unit=12,iostat=ios,err=100,
     /     file='ozone-high.dat',
     /     status='old',access=
     /     'sequential',form='formatted')
      read(unit=12,fmt=200,iostat=ios,err=300)
     /     t42
      
      open(unit=12,iostat=ios,err=100,
     /     file='ozone-low.dat',
     /     status='old',access=
     /     'sequential',form='formatted')
      read(unit=12,fmt=200,iostat=ios,err=300)
     /     t43
  100 print *,'err'
  300 print *,'err'
  200 format(' ',f15.5)
     
      do 10 i=1,1001
        y1(i)=(i-1)/10.0
        x11(i)=t11(i)
        x12(i)=t12(i)
   10 continue 

      do 20 i=1,1001
        y2(i)=(i-1)/10.0
        x21(i)=t21(i)
        x22(i)=t22(i)
        write(*,*)x21(i),x22(i)
   20 continue

      do 30 i=1,1001
        y3(i)=(i-1)/10.0
        x31(i)=t31(i)
        x32(i)=t32(i)
   30 continue

      do 40 i=1,1001
        y4(i)=(i-1)/10.0
        x41(i)=t41(i)
        x42(i)=t42(i)
        x43(i)=t43(i)
   40 continue

      write(6,*)'WORKSTATION ID (I) ? ;'
      call SGPWSN
      read(5,*)IWS
c      iws=1
      call GROPN(-IWS)
      call sldiv( 'y' , 2 , 2 )

      call GRFRM
      call GRSWND(200.,400.,0.,100.)
      call GRSVPT(0.2,0.8,0.2,0.8)
      call GRSTRN(1)
      call GRSTRF
      call USSTTL('temperature','K','height','km')
      call USDAXS
      call uulin(1001,x11,y1)
      call uuslnt( 2 )
      call uuslni( 3 )
      call uulin(1001,x12,y1)
      call uxmttl( 'T', 'flux'  ,0.0 )

      call GRFRM
      call GRSWND(200.,400.,0.,100.)
      call GRSVPT(0.2,0.8,0.2,0.8)
      call GRSTRN(1)
      call GRSTRF
      call USSTTL('temperature','K','height','km')
      call USDAXS
      call uuslnt( 1 )
      call uuslni( 1 )
      call uulin(1001,x21,y2)
      call uuslnt( 2 )
      call uuslni( 3 )
      call uulin(1001,x22,y2)
      call uxmttl( 'T', 'flux'  ,0.0 )

      call GRFRM
      call GRSWND(200.,400.,0.,100.)
      call GRSVPT(0.2,0.8,0.2,0.8)
      call GRSTRN(1)
      call GRSTRF
      call USSTTL('temperature','K','height','km')
      call USDAXS
      call uuslnt( 1 )
      call uuslni( 1 )
      call uulin(1001,x31,y3)
      call uuslnt( 2 )
      call uuslni( 3 )
      call uulin(1001,x32,y3)
      call uxmttl( 'T', 'flux'  ,0.0 )

      call GRFRM
      call GRSWND(200.,400.,0.,100.)
      call GRSVPT(0.2,0.8,0.2,0.8)
      call GRSTRN(1)
      call GRSTRF
      call USSTTL('temperature','K','height','km')
      call USDAXS
      call uuslnt( 1 )
      call uuslni( 1 )
      call uulin(1001,x41,y4)
      call uuslnt( 2 )
      call uuslni( 3 )
      call uulin(1001,x42,y4)
      call uuslnt( 3 )
      call uuslni( 4 )
      call uulin(1001,x43,y4)
      call uxmttl( 'T', 'flux'  ,0.0 )

      call grcls

      end











