*#########################  orig.f

************************************************************************
*     絤ήʿ(2ǥ)  1993.12.02 в
************************************************************************

*-----ѥ᥿----------------------------------------
      PARAMETER(N=1000)             !ʬ
      PARAMETER(ZT=100)             !絤ü
      PARAMETER(DZ=ZT/N)            !
      PARAMETER(SIGMA=5.7E-8)       !ƥե=ܥĥޥ
      PARAMETER(GAMMA=6.5)          !ǮΨ
      PARAMETER(ST=2.2E2)           !絤üǤβûȥեå
      DIMENSION Z(0:N)              !ľɸ
      DIMENSION Q(0:N)          !ûȵۼˤǮΨ
      DIMENSION S(0:N)              !ûȥեå
      DIMENSION A(0:N)              !ۼʪǻ١
      DIMENSION T(0:N)              !絤в

*-----ν------------------------------------------------------
      CALL INITZ(N,DZ,Z)            !Zν
      CALL INITQ(N,ST,Z,Q)          !Qν
      CALL INITS(N,DZ,ST,Q,S)       !Sν
      CALL INITA(N,Z,A)             !Aν
*-----ʿղʬۤη׻------------------------------------------------
      I=N+1
   10 CONTINUE
        I=I-1
        CALL GETU(N,I,DZ,SIGMA,GAMMA,Z,Q,S,A,T,U)  !T,Uη׻
        CALL GETV(N,I,DZ,SIGMA,A,T,V)              !Vη׻
      IF(V.GT.U) GOTO 10            !եåΥХ󥹤ɾ
      ZP=Z(I)                       !̹

*-----ɽ--------------------------------------------------------
      open(unit=12 ,iostat=ios,err=9000,
     /     file='co2.dat',
     /     status='new',access='sequential',form='formatted')
      write(unit=12,fmt=9020,iostat=ios,err=9010)
     /     t
 9000 print *,'err'
 9010 print *,'err'
 9020 format(' ',f15.5)

      CALL GRAPH(N,Z,T)

      END
************************************************************************
      SUBROUTINE INITZ(N,DZ,Z)

      DIMENSION Z(0:N)

      DO 10 I=0,N
        Z(I)=DZ*I
   10 CONTINUE
      END
************************************************************************
      SUBROUTINE INITQ(N,ST,Z,Q)    !ץץ

      PARAMETER(PI=3.141592)
      DIMENSION Z(0:N)
      DIMENSION Q(0:N)
      DATA EPS/0.02/                !絤ǤûȤεۼΨ
      DATA W/10.0/                  !ûȵۼؤθ
      DATA ZC/40.0/                 !ûȵۼؤ濴

      QC=ST*EPS/(SQRT(2*PI)*W)
      DO 10 I=0,N
        Q(I)=QC*EXP(-(Z(I)-ZC)*(Z(I)-ZC)/(2*W*W))
   10 CONTINUE

      END
************************************************************************
      SUBROUTINE INITS(N,DZ,ST,Q,S)

      DIMENSION Q(0:N)
      DIMENSION S(0:N)

      S(N)=ST
      DO 10 I=N,1,-1
        S(I-1)=S(I)-0.5*(Q(I)+Q(I-1))*DZ
   10 CONTINUE

      END
************************************************************************
      SUBROUTINE INITA(N,Z,A)       !ץץ

      DIMENSION Z(0:N)
      DIMENSION A(0:N)
      DATA A0/1.0/              !絤üǤA
      DATA H/8.0/                   !ۼʪʬۤΥϥ
      DO 10 I=0,N
        A(I)=A0*EXP(-Z(I)/H)
   10 CONTINUE
      END
************************************************************************
      SUBROUTINE GETU(N,I,DZ,SIGMA,GAMMA,Z,Q,S,A,T,U)

      DIMENSION Z(0:N)
      DIMENSION Q(0:N)
      DIMENSION S(0:N)
      DIMENSION A(0:N)
      DIMENSION T(0:N)
      DATA B/0.0/
      SAVE

      T(I)=((S(N)+B+Q(I)/A(I))/(2*SIGMA))**0.25
      U=0.5*(S(N)+B+S(I))           !طüǤξĹȥեå
      B=B+0.5*(A(I)*S(I)+A(I-1)*S(I-1))*DZ

      DO 10 J=0,I-1
        T(J)=T(I)-GAMMA*(Z(J)-Z(I))
   10 CONTINUE

      END
************************************************************************
      SUBROUTINE GETV(N,I,DZ,SIGMA,A,T,V)

      DIMENSION A(0:N)
      DIMENSION T(0:N)

      C=0
      E=0
      F=A(I)*SIGMA*T(I)**4
      DO 10 J=I,1,-1
        C=C+0.5*(A(J)+A(J-1))*DZ
        F1=A(J-1)*SIGMA*T(J-1)**4*EXP(-C)
        E=E+0.5*(F+F1)*DZ
        F=F1
   10 CONTINUE

      V=E+F                         !ήüǤξĹȥեå

      END
************************************************************************
      SUBROUTINE GRAPH(N,Z,T)

      DIMENSION Z(0:N)
      DIMENSION T(0:N)

      CALL GROPN(1)
      CALL GRFRM
      CALL USSTTL('TEMPERATURE','K','HEIGHT','KM')
      CALL USGRPH(N+1,T,Z)
      CALL GRCLS

      END
