*" ١ȤԤ֥롼Ǽ
*" 96/06/19 Ƿ
***********************************************************************
      SUBROUTINE U2Y(JMAX,OFS,U,Y) !" Y=U+OFS for cyclic data
      DIMENSION U(0:JMAX-1)
      DIMENSION Y(0:JMAX)

      DO 10 J=0,JMAX-1
        Y(J)=U(J)+OFS
   10 CONTINUE
      Y(JMAX)=Y(0)

      RETURN
      END
***********************************************************************
      SUBROUTINE U2YW(JMAX,FACT,OFS,U,Y) !" Y=U+OFS for cyclic data
      DIMENSION U(0:JMAX-1)
      DIMENSION Y(0:2*JMAX)

      DO 10 J=0,JMAX-1
        Y(J)=FACT*U(J)+OFS
        Y(J+JMAX)=FACT*U(J)+OFS
   10 CONTINUE
      Y(2*JMAX)=Y(0)

      RETURN
      END
***********************************************************************
      SUBROUTINE PIJIKX(CSIDE,DP1,DP2)
      CHARACTER  CSIDE*1
      REAL       DP1  !"       (ñ:)
      REAL       DP2  !" 礭ȥ٥(ñ:)
      PARAMETER  (MAX=100)
      REAL       U1(MAX),U2(MAX)
      CHARACTER  CU2(MAX)*9,CSGI*1
      LOGICAL    LEPSL,LREQ

      CALL GLPGET('LEPSL',LEPSL)
      CALL GLPSET('LEPSL',.TRUE.)
      CALL GLPGET('REPSL',REPSL)
      REPSL=REPSL/4

      IF(DP1.LE.0.) CALL MSGDMP('E','PIJIKX','NEGATIVE DIVISION')
      IF(DP2.LE.0.) CALL MSGDMP('E','PIJIKX','NEGATIVE DIVISION')

      PI=4*ATAN(1D0)
      D1=DP1*PI
      D2=DP2*PI
      CALL SGQWND(UXMIN,UXMAX,UYMIN,UYMAX)

      NU1=IRLE(UXMAX/D1)-IRGE(UXMIN/D1)+1
      IF(NU1.GT.MAX) THEN
        CALL MSGDMP('E','PIJIKX','WORKING AREA IS NOT ENOUGH')
      ELSE IF(NU1.LE.0) THEN
        CALL MSGDMP('E','PIJIKX','NO TICKMARK')
      ENDIF

      U1(1)=IRGE(UXMIN/D1)*D1
      DO 10 N=2,NU1
        U1(N)=U1(N-1)+D1
   10 CONTINUE

      NU2=IRLE(UXMAX/D2)-IRGE(UXMIN/D2)+1
      IF(NU2.GT.MAX) THEN
        CALL MSGDMP('E','PIJIKX','WORKING AREA IS NOT ENOUGH')
      ELSE IF(NU2.LE.0) THEN
        CALL MSGDMP('E','PIJIKX','NO TICKMARK/LABEL')
      ENDIF

      U2(1)=IRGE(UXMIN/D2)*D2
      UP2=U2(1)/PI
      DO 20 N=2,NU2
        U2(N)=U2(N-1)+D2
   20 CONTINUE

      IF(LREQ(DP2,REAL(INT(DP2+REPSL)))) THEN
        DO 50 N=1,NU2
          UP=UP2+DP2*(N-1)
          IF(LREQ(UP,1.)) THEN
            CU2(N)=CSGI(167)
          ELSE IF(LREQ(UP,0.)) THEN
            CU2(N)='0'
          ELSE IF(LREQ(UP,-1.)) THEN
            CU2(N)='-'//CSGI(167)
          ELSE
            CALL CHVAL('(I)',UP,CU2(N))
            IL=LENC(CU2(N))
            CU2(N)(IL+1:IL+1)=CSGI(167)
          ENDIF
   50   CONTINUE
      ELSE IF(LREQ(2*DP2,REAL(INT(2*DP2+REPSL)))) THEN
        DO 60 N=1,NU2
          UP=UP2+DP2*(N-1)
          IF(LREQ(UP,1.)) THEN
            CU2(N)=CSGI(167)
          ELSE IF(LREQ(UP,0.)) THEN
            CU2(N)='0'
          ELSE IF(LREQ(UP,-1.)) THEN
            CU2(N)='-'//CSGI(167)
          ELSE IF(LREQ(UP,REAL(INT(UP+REPSL)))) THEN
            CALL CHVAL('(I)',UP,CU2(N))
            IL=LENC(CU2(N))
            CU2(N)(IL+1:IL+1)=CSGI(167)
          ELSE
            IF(LREQ(2*UP,1.))THEN
              CU2(N)=CSGI(167)//'/2'
            ELSE IF(LREQ(2*UP,-1.))THEN
              CU2(N)='-'//CSGI(167)//'/2'
            ELSE
              CALL CHVAL('(I)',2*UP,CU2(N))
              IL=LENC(CU2(N))
              CU2(N)(IL+1:IL+1)=CSGI(167)
              CU2(N)(IL+2:IL+3)='/2'
            ENDIF
          ENDIF
   60   CONTINUE
      ELSE IF(LREQ(3*DP2,REAL(INT(3*DP2+REPSL)))) THEN
        DO 70 N=1,NU2
          UP=UP2+DP2*(N-1)
          IF(LREQ(UP,1.)) THEN
            CU2(N)=CSGI(167)
          ELSE IF(LREQ(UP,0.)) THEN
            CU2(N)='0'
          ELSE IF(LREQ(UP,-1.)) THEN
            CU2(N)='-'//CSGI(167)
          ELSE IF(LREQ(UP,REAL(INT(UP+REPSL)))) THEN
            CALL CHVAL('(I)',UP,CU2(N))
            IL=LENC(CU2(N))
            CU2(N)(IL+1:IL+1)=CSGI(167)
          ELSE
            IF(LREQ(3*UP,1.))THEN
              CU2(N)=CSGI(167)//'/3'
            ELSE IF(LREQ(3*UP,-1.))THEN
              CU2(N)='-'//CSGI(167)//'/3'
            ELSE
              CALL CHVAL('(I)',3*UP,CU2(N))
              IL=LENC(CU2(N))
              CU2(N)(IL+1:IL+1)=CSGI(167)
              CU2(N)(IL+2:IL+3)='/3'
            ENDIF
          ENDIF
   70   CONTINUE
      ELSE IF(LREQ(4*DP2,REAL(INT(4*DP2+REPSL)))) THEN
        DO 80 N=1,NU2
          UP=UP2+DP2*(N-1)
          IF(LREQ(UP,1.)) THEN
            CU2(N)=CSGI(167)
          ELSE IF(LREQ(UP,0.)) THEN
            CU2(N)='0'
          ELSE IF(LREQ(UP,-1.)) THEN
            CU2(N)='-'//CSGI(167)
          ELSE IF(LREQ(UP,REAL(INT(UP+REPSL)))) THEN
            CALL CHVAL('(I)',UP,CU2(N))
            IL=LENC(CU2(N))
            CU2(N)(IL+1:IL+1)=CSGI(167)
          ELSE IF(LREQ(2*UP,REAL(INT(2*UP+REPSL)))) THEN
            IF(LREQ(2*UP,1.))THEN
              CU2(N)=CSGI(167)//'/2'
            ELSE IF(LREQ(2*UP,-1.))THEN
              CU2(N)='-'//CSGI(167)//'/2'
            ELSE
              CALL CHVAL('(I)',2*UP,CU2(N))
              IL=LENC(CU2(N))
              CU2(N)(IL+1:IL+1)=CSGI(167)
              CU2(N)(IL+2:IL+3)='/2'
            ENDIF
          ELSE
            IF(LREQ(4*UP,1.))THEN
              CU2(N)=CSGI(167)//'/4'
            ELSE IF(LREQ(4*UP,-1.))THEN
              CU2(N)='-'//CSGI(167)//'/4'
            ELSE
              CALL CHVAL('(I)',4*UP,CU2(N))
              IL=LENC(CU2(N))
              CU2(N)(IL+1:IL+1)=CSGI(167)
              CU2(N)(IL+2:IL+3)='/4'
            ENDIF
          ENDIF
   80   CONTINUE
      ELSE
        CALL MSGDMP('E','PIJIKX','SORRY HAVEN''T BE SUPPORTED YET')
      ENDIF

      CALL UXAXLB(CSIDE,U1,NU1,U2,CU2,9,NU2)

      CALL GLPSET('LEPSL',LEPSL)

      RETURN
      END
