*----------------------------------------------------------------------
*     եν
*----------------------------------------------------------------------
      subroutine grfini(z, vorfct)

      include 'incpa.f'
      parameter(pi=3.141593)
      parameter(vymin=0.17,vymax=0.62)  ! ӥ塼ݡ y ɸκǾ, 
cc      parameter(vymin=0.17,vymax=0.54)  ! ӥ塼ݡ y ɸκǾ, 
      parameter(xymin=0.,xymax=2*pi)    ! ɥ(x,y)ɸκǾ, 
      parameter(rkmin=1.,rkmax=1.e2)    ! 
      parameter(emin=1.e-6,emax=1.)     ! 
      parameter(nxy1=17,nxy2=5)         ! 礭(٥)ο
ccc      parameter(ntone=18,ipat0=20,idlev=4) ! , ֹν, ʬ
ccc      parameter(ntone=35,ipat0=20,idlev=2) ! , ֹν, ʬ
      parameter(ntone=69,ipat0=21,idlev=1) ! , ֹν, ʬ

      real z(-lm:lm,-km:km)                ! ٤Υڥȥ뷸
      real vor(0:im,0:jm)                  ! եå˻Ȥ
      real ene1d(jmax,0:imax),rkappa(jmax)
      real rbar(2*ntone,2)                 ! 顼С
      real rxy1(nxy1),rxy2(nxy2)           ! 
      character cxy2(nxy2)*4               ! ٥
      character ctime*5,ct*70,csgi*1

      save
*-----+--1---------2---------3---------4---------5---------6---------7-+
      call gllset('lmiss',  .true.)
      call glrget('rmiss',  rmiss)
      call swiset('iwidth', 720)
      call swiset('iheight',520)
      call swlset('lwait',  .false.)
      call swlset('lalt',   .true.)
      call sglset('lcorner',.false.)
      call sglset('lclip',  .true.)
      call sglset('lcntl',  .true.)
      call sglset('lfull',  .true.)

* udpack 
      call udlset('lmsg',  .false.)
      call udsfmt('(i2)')
      call udiset('indxmj', 991)
      call udiset('indxmn', 991)
      call udiset('icycle',   1)
      call udrset('rsizel', 0.012)
      call udgcla(-5., 5., 1.)

* uepack 
      call sbvor(z, vor)
      rgmin = rmin(vor, (im+1)*(jm+1), 1)
      rgmax = rmax(vor, (im+1)*(jm+1), 1)
      write(*,*)  'min. vorticity = ', rgmin,
     +          '  max. vorticity = ', rgmax

      if(rgmax .gt. abs(rgmin)) then
        rgmax =   rgmax*vorfct
        rgmin = - rgmax
      else
        rgmin =   rgmin*vorfct
        rgmax = - rgmin
      end if

      do i=1,2*ntone
        rbar(i,1) = rgmin + (rgmax-rgmin)*(i-1)/(2*ntone-1)
        rbar(i,2) = rbar(i,1)
      end do
      dxma = (rgmax-rgmin)/2
      dxma = rgnle(dxma)
      dxmi = dxma/2

c      rgmin = rgnle(rgmin)
c      rgmax = rgnge(rgmax)
      dlev = (rgmax-rgmin)/(ntone-2)
      rbmin = rgmin + dlev
      call gnle(rgmin, bxmin, ipmin)
      call gnle(rgmax, bxmax, ipmax)
      if(ipmin .le. -4) then
        iof = 2
      else if(ipmax .le. -4) then
        iof = 4
      else
        iof = 3
      end if

      do i=1,ntone
        ipat = (ipat0 + (i-1)*idlev)*1000 + 999
        tlev1 = rbmin + (i-iof)*dlev
        tlev2 = tlev1 + dlev
        if(i .eq.     1) tlev1 = rmiss
        if(i .eq. ntone) tlev2 = rmiss
        call uestlv(tlev1, tlev2, ipat)
      end do

* uzpack 
      call uzfact(0.75)
      call uzrset('uxuser',  0.0)
      call uzlset('labelyu', .false.)

      axdel1 = (xymax-xymin)/(nxy1-1)
      do l=1,nxy1
        rxy1(l) = xymin + (l-1)*axdel1
      end do

      axdel2 = (xymax-xymin)/(nxy2-1)
      do l=1,nxy2
        rxy2(l) = xymin + (l-1)*axdel2
      end do

      cxy2(1) = '0'
      cxy2(2) =        csgi(167) // '/2'
      cxy2(3) =        csgi(167)
      cxy2(4) = '3' // csgi(167) // '/2'
      cxy2(5) = '2' // csgi(167)

* ȿ
      do j=1,jmax
        rkappa(j) = j
      end do

      call gropn(1)

      return
*----------------------------------------------------------------------
*     եɽ
*----------------------------------------------------------------------
      entry grfdrw(ijk, t, z, ene1d)

* 1ͥ륮ڥȥ
      call grfrm
      call grswnd(rkmin, rkmax,  emin,  emax)
      call grsvpt( 0.12,  0.40, vymin, vymax)
      call grstrn(4)
      call grstrf

      call ulxlog('b', 1, 9)
      call ulxlog('t', 1, 9)
      call uxsttl('b', 'wavenumber', 0.0)
      call ulylog('l', 1, 9)
      call ulylog('r', 1, 9)
      call uysttl('l', 'Energy', 0.0)
      call uxsttl('t',' ', -0.8)
      write(ctime,'(f5.2)') t
      call uxsttl('t','T='//ctime, -0.8)

      if(t .ne. 0) then
        call sgspli(81)
        do ii=0,ijk,10
          call sgplu(jmax, rkappa, ene1d(1,ii))
        end do
      end if

      call sgslni(91)
      call sglnu(rkmin, 1.e1, rkmax, 1.e-5)
      call sglnu(rkmin, 1.e3, rkmax, 1.e-5)

      call sgspli(22)
      call sgplu(jmax, rkappa, ene1d(1,ijk))
      
* پ
      call sbvor(z, vor)

      call grfig
      call grswnd(xymin, xymax, xymin, xymax)
      call grsvpt( 0.51,  0.96, vymin, vymax)
      call grstrn(1)
      call grstrf

      call uetong(vor, im+1, im+1, jm+1)
cc      call uetonf(vor, im+1, im+1, jm+1)
ccc      call uetone(vor, im+1, im+1, jm+1)

      call uxaxlb('b', rxy1, nxy1, rxy2, cxy2, 4, nxy2)
      call uxaxdv('t', pi/8., pi/2.) 
      call uyaxlb('l', rxy1, nxy1, rxy2, cxy2, 4, nxy2)
      call uyaxdv('r', pi/8., pi/2.) 
      ct = 'vorticity field:' // csgi(157) // '(x,y)'
      call uxsttl('t', ct, -1.0)

*- color bar
      call grfig
      call grsvpt(     0.51,             0.8, 0.04, 0.08)
      call grswnd(rbar(1,1), rbar(2*ntone,1),  0.0,  1.0)
      call grstrn(1)
      call grstrf

      call uetone(rbar, 2*ntone, 2*ntone, 2)
      call uxaxdv('b', dxmi, dxma)
      call uxaxdv('t', dxmi, dxma) 
      call uzlset('labelyl',.false.)
      call uyaxdv('l', 1., 1.)
      call uzlset('labelyl',.true.)
      call uyaxdv('r', 1., 1.) 
      call uxsttl('t', csgi(157), 0.0)

      return
*----------------------------------------------------------------------
*     λ
*----------------------------------------------------------------------
      entry grfcls

      write(6,*) 'Calculation is over. Click the mouse button.'

      call grcls

      end
*-----------------------------------------------------------------------
      SUBROUTINE UETONG(Z,MX,NX,NY)

      REAL      Z(MX,*)

      REAL      XC(4),YC(4)

      COMMON    /UEBLK1/ TL1,TL2,IPT,NT,LASCND
      PARAMETER (MAXNT=100)
      LOGICAL   LASCND
      INTEGER   IPT(MAXNT)
      REAL      TL1(MAXNT),TL2(MAXNT)

      EXTERNAL  RUWGX,RUWGY


*     / GET INTERNAL PARAMETERS /

      CALL SGIGET('ITR     ',ITR)

*     / SET GRID ATTRIBUTE IF IT HAS NOT BEEN SET YET /

      CALL UWDFLT(NX,NY)

*     / CHECK Z VALUES AND TONE LEVEL /

      CALL UEZCHK(Z,MX,NX,NY,'UETONE',ISTAT)
      IF (ISTAT.NE.0) RETURN

*     / SET TONE MODE (IRMODE) /

      CALL UWQGXB(UXMIN,UXMAX,NXZ)
      CALL UWQGYB(UYMIN,UYMAX,NYZ)

      IF (ITR.LT.4) THEN
        CALL STFTRF(UXMIN,UYMIN,VXMIN,VYMIN)
        CALL STFTRF(UXMAX,UYMAX,VXMAX,VYMAX)
        DX=VXMAX-VXMIN
        DY=VYMAX-VYMIN
      ELSE
        DX=UXMAX-UXMIN
        DY=UYMAX-UYMIN
      END IF

      IRMODE=0
      IF (DX.LT.0) IRMODE=MOD(IRMODE+1,2)
      IF (DY.LT.0) IRMODE=MOD(IRMODE+1,2)

      CALL SGISET('IRMODE', IRMODE)

*     / LOOP FOR EACH TONE PATTERN /

      DO 30 IT=1,NT

        CALL SZTNOP(IPT(IT))

*       / LOOP FOR EACH SECTION /

        DO 20 I=1,NX

          IM=MAX(I-1,1)
          IP=MIN(I+1,NX)
          XCC  = RUWGX(I)
          XC(1)=(RUWGX(IM)+XCC)/2.
          XC(2)=(RUWGX(IP)+XCC)/2.
          XC(3)=XC(2)
          XC(4)=XC(1)

          DO 10 J=1,NY

            IF (Z(I,J).LT.TL1(IT)) GO TO 10
            IF (Z(I,J).GT.TL2(IT)) GO TO 10

            JM=MAX(J-1,1)
            JP=MIN(J+1,NY)
            YCC  = RUWGY(J)
            YC(1)=(RUWGY(JM)+YCC)/2.
            YC(2)=YC(1)
            YC(3)=(RUWGY(JP)+YCC)/2.
            YC(4)=YC(3)

            CALL SZTNZU(4,XC,YC)

   10     CONTINUE
   20   CONTINUE

        CALL SZTNCL

   30 CONTINUE

      END
*-----------------------------------------------------------------------
      SUBROUTINE UETONF2(Z,MX,NX,NY,IXRES,IYRES)

      REAL      Z(MX,*)

      PARAMETER (MAXPXL=1000)
      PARAMETER (ITRANS=-999)

      INTEGER   IMAGE(MAXPXL)
      LOGICAL   LMISS,LIMC

      EXTERNAL  IUETON


*     / CHECK IMAGE CAPABILITY /

      CALL SWQIMC(LIMC)
      IF (.NOT.LIMC) THEN
        CALL MSGDMP('E','UETONF2','NO IMAGE CAPABILITY.')
      END IF

*     / GET INTERNAL PARAMETERS /

      CALL GLRGET('RUNDEF  ',RUNDEF)
      CALL GLIGET('IUNDEF  ',IUNDEF)
      CALL GLLGET('LMISS   ',LMISS )
      CALL GLRGET('RMISS   ',RMISS )

*     / SET GRID ATTRIBUTE IF IT HAS NOT BEEN SET YET /

      CALL UWDFLT(NX, NY)

*     / CHECK Z VALUES AND TONE LEVEL /

      CALL UEZCHK(Z,MX,NX,NY,'UETONF',ISTAT)
      IF (ISTAT.NE.0) RETURN

*     / INITIALIZE /

      CALL SGQVPT(VXMIN, VXMAX, VYMIN, VYMAX)

      CALL STFPR2(VXMIN, VYMIN, RX, RY)
      CALL STFWTR(RX, RY, WX, WY)
      CALL SWFINT(WX, WY, IX1, IY1)

      CALL STFPR2(VXMAX, VYMAX, RX, RY)
      CALL STFWTR(RX, RY, WX, WY)
      CALL SWFINT(WX, WY, IX2, IY2)

      IWIDTH = ABS(IX1-IX2)+1
      IHIGHT = ABS(IY1-IY2)+1
      IXMIN  = MIN(IX1, IX2)
      IYMIN  = MIN(IY1, IY2)
      INUM   = IWIDTH/IXRES
      JNUM   = IHIGHT/IYRES
      IWIDTH = INUM*IXRES
      IHIGHT = JNUM*IYRES

      CALL SWIOPN(IXMIN, IYMIN, IWIDTH, IHIGHT)


*     / LOOP FOR EACH PIXEL /

      DO 30 JS=1, IHIGHT, IYRES
        JE = MIN(JS+IYRES-1, IHIGHT)
        J  = (JS+JE)/2

        DO 20 IS=1, IWIDTH, IXRES
          IE = MIN(IS+IXRES-1, IWIDTH)
          I  = (IS+IE)/2

          CALL SWIINT(I+IXMIN-1, J+IYMIN-1, WX, WY)
          CALL STIWTR(WX, WY, RX, RY)
          CALL STIPR2(RX, RY, VX, VY)
          CALL STITRF(VX, VY, UX, UY)

          IF (UX.EQ.RUNDEF) THEN
            IMAGE(IE) = ITRANS
          ELSE
            CALL UWQGXI(UX,IX,FX)
            CALL UWQGYI(UY,IY,FY)
            IF (IX.EQ.IUNDEF .OR. IY.EQ.IUNDEF) THEN
              IMAGE(IE) = ITRANS
            ELSE
              IF (LMISS .AND.
     +             (Z(IX  , IY  ).EQ.RMISS .OR.
     +              Z(IX+1, IY  ).EQ.RMISS .OR.
     +              Z(IX  , IY+1).EQ.RMISS .OR.
     +              Z(IX+1, IY+1).EQ.RMISS)     ) THEN
                F00 = (1-FX)*(1-FY)
                F10 =    FX *(1-FY)
                F01 = (1-FX)*   FY
                F11 =    FX *   FY
                FF  = 1
                IF (Z(IX  , IY  ).EQ.RMISS) THEN
                   F00 = 0.
                   IF (FX.LT.0.5 .AND. FY.LT.0.5) FF=0.
                ENDIF
                IF (Z(IX+1, IY  ).EQ.RMISS) THEN
                   F10 = 0
                   IF (FX.GT.0.5 .AND. FY.LT.0.5) FF=0.
                ENDIF
                IF (Z(IX  , IY+1).EQ.RMISS) THEN
                   F01 = 0.
                   IF (FX.LT.0.5 .AND. FY.GT.0.5) FF=0.
                ENDIF
                IF (Z(IX+1, IY+1).EQ.RMISS) THEN
                   F11 = 0
                   IF (FX.GT.0.5 .AND. FY.GT.0.5) FF=0.
                ENDIF
                FF = FF*(F00+F10+F01+F11)
                IF ( FF .GT. 0. ) THEN
                   ZZ = Z(IX, IY  )*F00 + Z(IX+1,IY  )*F10
     +                + Z(IX, IY+1)*F01 + Z(IX+1,IY+1)*F11
                   IMAGE(IE) = IUETON(ZZ/FF)/1000
                ELSE
                   IMAGE(IE) = ITRANS
                ENDIF
              ELSE
                ZZ = (Z(IX, IY  )*(1-FX) + Z(IX+1,IY  )*FX)*(1-FY)
     +             + (Z(IX, IY+1)*(1-FX) + Z(IX+1,IY+1)*FX)*FY
                IMAGE(IE) = IUETON(ZZ)/1000
              END IF
            END IF
          END IF
          DO 21 II = IS, IE-1
             IMAGE(II)=IMAGE(IE)
   21     CONTINUE 

   20   CONTINUE

        CALL SWIDAT(IMAGE, INUM)

        DO 31 JJ = JS, JE
           CALL SWIDAT(IMAGE, IWIDTH)
   31   CONTINUE 

   30 CONTINUE

      CALL SWICLS

      END
********************************************************************************
