********************************************************************************
* ɽ ϵήϳ ׻¸
*
*     2ή¸
*     total energy, total enstrophy, mean wavenumber λѲ
*
*  99/07/19 ;  
********************************************************************************
      program timev

      include 'incpa.f'
      parameter(vxmi1=0.06,vxmi2=0.39,vxmi3=2*vxmi2-vxmi1,vxdel=0.26)
      parameter(vymi2=0.07,vymi1=0.41,vydel=0.26)

      real z(-lm:lm,-km:km)                      ! ٤Υڥȥ뷸
      real ene(0:imax), ens(0:imax), rmk(0:imax), time(0:imax)
*-----+--1---------2---------3---------4---------5---------6---------7-+
* open file and read initial dara
      open(51,file='turb1.data',form='unformatted')

* computation
      do i=0,imax
        read(51) t, z

        time(i) = t
         ene(i) = 0.0
         ens(i) = 0.0
         rmk(i) = 0.0

        do k=-km,km
          do l=-lm,lm
            if(k.ne.0 .or. l.ne.0) then
              energy = 0.5*z(l,k)**2/(k**2+l**2)
              ene(i) = ene(i) + energy
              ens(i) = ens(i) + 0.5*z(l,k)**2
              rmk(i) = rmk(i) + sqrt(real(k**2+l**2))*energy
            end if
          end do
        end do
        rmk(i) = rmk(i)/ene(i)
      end do

* graphics
      call glrget('rundef', rundef)
      call swiset('iwidth', 720)
      call swiset('iheight',540)
      call sglset('lcorner',.false.)
      call sglset('lclip',  .true.)
      call sglset('lcntl',  .true.)
      call sglset('lfull',  .true.)
      call uzfact(0.7)

      call gropn(1)

* 1ͥ륮ڥȥ()
      call grfrm
      call usspnt(imax+1, rundef, ene)
      call grswnd(time(0), time(imax), 0.0, rundef)
      call grsvpt(vxmi1, vxmi1+vxdel, vymi1, vymi1+vydel)
      call uspfit
      call grstrf

      call usdaxs
      call uxsttl('b', 'TIME', 0.0)
      call uxsttl('t', 'ENERGY', -1.0)
      call uxsttl('t', 'TOTAL', -1.0)

      call sgspli(42)
      call sgplu(imax+1, time, ene)

* 1󥹥ȥեڥȥ()
      call grfig
      call usspnt(imax+1, rundef, ens)
      call grswnd(time(0), time(imax), 0.0, rundef)
      call grsvpt(vxmi2, vxmi2+vxdel, vymi1, vymi1+vydel)
      call uspfit
      call grstrf

      call usdaxs
      call uxsttl('b', 'TIME', 0.0)
      call uxsttl('t', 'ENSTROPHY', -1.0)
      call uxsttl('t', 'TOTAL', -1.0)

      call sgspli(32)
      call sgplu(imax+1, time, ens)

* ʿȿ()
      call grfig
      call usspnt(imax+1, rundef, rmk)
      call grswnd(time(0), time(imax), 0.0, rundef)
      call grsvpt(vxmi3, vxmi3+vxdel, vymi1, vymi1+vydel)
      call uspfit
      call grstrf

      call usdaxs
      call uxsttl('b', 'TIME', 0.0)
      call uxsttl('t', 'WAVENUMBER', -1.0)
      call uxsttl('t', 'MEAN', -1.0)

      call sgspli(22)
      call sgplu(imax+1, time, rmk)

* 1ͥ륮ڥȥ(п)
      call grfig
      call usspnt(imax+1, rundef, ene)
      call grswnd(time(1), time(imax), rundef, rundef)
      call grsvpt(vxmi1, vxmi1+vxdel, vymi2, vymi2+vydel)
      call uspfit
      call grstrn(4)
      call grstrf

      call usdaxs
      call uxsttl('b', 'TIME', 0.0)

      call sgspli(42)
      call sgplu(imax, time(1), ene(1))

* 1󥹥ȥեڥȥ(п)
      call grfig
      call usspnt(imax+1, rundef, ens)
      call grswnd(time(1), time(imax), rundef, rundef)
      call grsvpt(vxmi2, vxmi2+vxdel, vymi2, vymi2+vydel)
      call uspfit
      call grstrn(4)
      call grstrf

      call usdaxs
      call uxsttl('b', 'TIME', 0.0)

      call sgspli(32)
      call sgplu(imax, time(1), ens(1))

* ʿȿ(п)
      call grfig
      call usspnt(imax+1, rundef, rmk)
      call grswnd(time(1), time(imax), rundef, rundef)
      call grsvpt(vxmi3, vxmi3+vxdel, vymi2, vymi2+vydel)
      call uspfit
      call grstrn(4)
      call grstrf

      call usdaxs
      call uxsttl('b', 'TIME', 0.0)

      call sgspli(22)
      call sgplu(imax, time(1), rmk(1))

      call grcls

      stop
      end
********************************************************************************
