********************************************************************************
* ɽ ϵήϳ ׻¸
*
*      3оʿձ Thorpe(1985)ήطǥ
*      3D graphics
*
*  99/07/02 ; 
********************************************************************************
      program graf2d

      implicit real*8(a-h,o-z)
      include 'incpa.f'
      dimension phi(-1:imax,-1:jmax)                     ! potential function
      integer    ij(-1:imax)                             ! ̥٥ֹ
      real v(0:imax-1,0:jmax-1),theta(0:imax-1,0:jmax-1) ! ս(ñ)
*-----+--1---------2---------3---------4---------5---------6---------7-+
* ǡɤ߹
      open (51,file='thorpe1.data', form='unformatted')
      read (51) ij, phi
      close(51)

* v, theta η׻
      call vtheta(phi, v, theta)

* ս(2D)
      call graph(v, theta, ij)

      stop
      end
********************************************************************************
      subroutine vtheta(phi, v, theta)

      implicit real*8(a-h,o-z)
      include 'incpa.f'
      dimension phi(-1:imax,-1:jmax)                     ! potential function
      real v(0:imax-1,0:jmax-1),theta(0:imax-1,0:jmax-1) ! ս(ñ)
*-----+--1---------2---------3---------4---------5---------6---------7-+
* v, theta η׻
      do i=0,imax-1
        do j=0,jmax-1
          delr = phi(i+1,j  ) - phi(i-1,j  )
          delz = phi(i  ,j+1) - phi(i  ,j-1)

          if(i .eq. 0) then
            v(i,j) = 0.0
          else
            v(i,j) = delr*rn*h /(2d0*dr*sqrt( 1d0 + delr/(i*dr**2) ))
          end if
          theta(i,j) = delz/(2d0*dz) *theta0*rn**2 *h/g   + theta0
        end do
      end do

      return
      end
********************************************************************************
      subroutine graph(v, theta, ij)

      include 'incpa.f'

      real v(0:imax-1,0:jmax-1),theta(0:imax-1,0:jmax-1) ! ս(ñ)
      real         x(-1:imax),z(-1:imax)
      integer     ij(-1:imax)                            ! ̥٥ֹ
      character csgi*1
*-----+--1---------2---------3---------4---------5---------6---------7-+
      xmin = 0.0
      zmin = 0.0
      xmax = (imax-1)*dr                ! Ⱦκ r=r0=xmax
      xmax = xmax*rn*h/f0/1000.         ! [km]
      zmax = (jmax-1)*dz                ! ľκ z=h =ymax
      zmax = zmax*h/1000.               ! [km]

      do i=0,imax-1
        x(i) = i*dr *rn*h/f0/1000.   
        z(i) = ij(i)*dz *h/1000.
      end do
      x(-1)   = x(0)
      z(-1)   = zmax
      x(imax) = x(imax-1)
      z(imax) = zmax

      call swiset('iwidth', 540)
      call swiset('iheight',540)
      call udlset('lmsg', .false.)
      call udsfmt('(i3)')

      call gropn(1)
      call grfrm
      call grswnd(xmin, xmax, zmin, zmax)
      call grsvpt(0.15, 0.95, 0.58, 0.93)
      call grstrn(1)
      call grstrf

      call sgstnp(9999)
      call sgtnu(imax+2, x, z)

      call uzlset('labelxb',.false.)
      call uxaxdv('b', 1000., 2000.)
      call uzlset('labelxb',.true.)
      call uxaxdv('t', 1000., 2000.)
      call uyaxdv('l', 1., 5.)
      call uyaxdv('r', 1., 5.)
      call uxmttl('t', 'v [m/s]', -0.7) 
      call uymttl('l', 'z [km]', 0.0) 
      call udiclv
      call udgclb(v, imax, imax, jmax, 1.)
      call udcntr(v, imax, imax, jmax)

      call grfig
      call grswnd(xmin, xmax, zmin, zmax )
      call grsvpt(0.15, 0.95, 0.12, 0.47 )
      call grstrn( 1 )
      call grstrf

      call sgstnp(9999)
      call sgtnu(imax+2, x, z)

      call uxaxdv('b', 1000., 2000.)
      call uxaxdv('t', 1000., 2000.)
      call uyaxdv('l', 1., 5. )
      call uyaxdv('r', 1., 5. )
      call uxmttl('t', csgi(135)//' [K]', -0.7) 
      call uymttl('l', 'z [km]', 0.0) 
      call uxmttl('b', 'r [km]', 0.0)
      call udiclv
      call udgclb(theta, imax, imax, jmax, 5.)
      call udcntr(theta, imax, imax, jmax)

      call grcls
      return
      end
********************************************************************************

