********************************************************************************
*     եϢ֥롼
********************************************************************************
      subroutine grfini

* graphic initialize
      call swistx('iwidth', 540)
      call swistx('iheight',540)
      call swlstx('lalt',.true.)      ! draw at dummy screen
      call swlstx('lwait',.false.)    ! not pause for repage
*      call swlset('ldump',.true.)
      call sglset('lclip',.true.)
      call sglset('lcorner',.false.)  ! no corner mark
      call gropn(1)

      return
      end
********************************************************************************
      subroutine anim1(kring, dtime, nnode, dx, dlambd, dqjmp)

*     graphic animation

      implicit real*8(d)

      include 'incpa.f'
      parameter(xmin=-1.6,xmax=1.6,ymin=-1.6,ymax=1.6)

      dimension dx(2,0:ndmax+2,nring)   ! particle position
      real      sx(ndmax+1,2)           ! particle position
      integer   nnode(nring)            ! number of nodes
      character ctitle*25,csgi*1,ct1*13
*-----+--1---------2---------3---------4---------5---------6---------7-+
      call grfrm
      call grswnd(xmin, xmax, ymin, ymax)
      call grsvpt(0.15,  0.9, 0.15,  0.9)
      call grstrn(1)
      call grstrf

      call uxaxdv('b', 0.2, 1.0)
      call uxaxdv('t', 0.2, 1.0)
      call uxsttl('b', 'X', 0.0)
      call uyaxdv('l', 0.2, 1.0)
      call uyaxdv('r', 0.2, 1.0)
      call uysttl('l', 'Y', 0.0)

      slambd = real(dlambd)
      st = real(dtime)
      ct1 = '=&&&; T=%%%%%'
      call chngr(ct1, '&&&', slambd, '(f3.1)')
      call chngr(ct1, '%%%%%', st, '(f5.2)')
      ctitle = csgi(162) // ct1
      call uxsttl('t', ctitle, -1.0)

      do k=kring,1,-1
        do i=1,2
          do j=1,nnode(k)
            sx(j,i) = real( dx(i,j,k) )
          end do
          sx(nnode(k)+1,i) = sx(1,i)
        end do

        if(k .eq. 1)then
          call sgspli(22)
        else
          call sgspli(722)
        end if

        call sgplu(nnode(k)+1, sx(1,1), sx(1,2))

ccc        call sgstnp(k*2000+999)
ccc        call sgtnu(nnode(k)+1, sx(1,1), sx(1,2))
      end do

* linear solition
        pi = 4*atan(1.0)
        slambd = real(dlambd)
        theta = dqjmp*slambd*st / (1.0+slambd)**2
        ct = cos(theta)
        st = sin(theta)
        call sgrset('afact', 0.0)
        call sglazu(-1.5*ct, -1.5*st, 1.5*ct,  1.5*st, 1, 81)
        call sglazu(-0.5*st,  0.5*ct, 0.5*st, -0.5*ct, 1, 81)

      return
      end 
********************************************************************************
      subroutine anim2(kring, dtime, nnode, dx)

*     graphic animation

      implicit real*8(d)

      include 'incpa.f'
      parameter(xmin=-1.6,xmax=1.6,ymin=-1.6,ymax=1.6)

      dimension dx(2,0:ndmax+2,nring)   ! particle position
      real      sx(ndmax+1,2)           ! particle position
      integer   nnode(nring)            ! number of nodes
      character ct*15
*-----+--1---------2---------3---------4---------5---------6---------7-+
      call grfrm
      call grswnd(xmin, xmax, ymin, ymax)
      call grsvpt(0.15,  0.9, 0.15,  0.9)
      call grstrn(1)
      call grstrf

      call uxaxdv('b', 0.2, 1.0)
      call uxaxdv('t', 0.2, 1.0)
      call uxsttl('b', 'X', 0.0)
      call uyaxdv('l', 0.2, 1.0)
      call uyaxdv('r', 0.2, 1.0)
      call uysttl('l', 'Y', 0.0)

      st = real(dtime)
      ct = 'T=%%%%%'
      call chngr(ct, '%%%%%', st, '(f5.2)')
      call uxsttl('t', ct, 1.0)

      do k=1,kring
        do i=1,2
          do j=1,nnode(k)
            sx(j,i) = real( dx(i,j,k) )
          end do
          sx(nnode(k)+1,i) = sx(1,i)
        end do

*        call sgspli(k*20+2)
        call sgspli(20+2)
        call sgplu(nnode(k)+1, sx(1,1), sx(1,2))

ccc        call sgstnp(k*2000+999)
ccc        call sgtnu(nnode(k)+1, sx(1,1), sx(1,2))
      end do

      return
      end 
********************************************************************************
      subroutine grfcls

      call grcls
      
      return
      end
********************************************************************************



        






