********************************************************************************
* ɽ ϵήϳ ׻¸
*
*     Graphic program for spectral model
*     ǡ򥢥˥᡼Ǹ
*
*  99/06/25 ;  
********************************************************************************
      program replay

      implicit real*8(d)

      include 'incpa.f'

      dimension dx(2,0:ndmax+2,nring)     ! particle position
      dimension dqjump(nring)             ! vorticity jump
      integer   nnode(nring)              ! number of nodes
      character cfname*8
*-----+--1---------2---------3---------4---------5---------6---------7-+
* kringj:  =1 (ʱ߱), =2 (лұ)
      write(*,*) 'input experiment #:'
      write(*,*) '    kringj=1: elliptic vortex'
      write(*,*) '           2: twin vortices'
      write(*,*) 'kringj= ?'
      read(*,*) kringj                    ! number of contour rings with q gap

      if(kringj.ne.1 .and. kringj.ne.2) stop 'kringj must be 1 or 2'
      cfname = 'cd?.data'
      write(cfname(3:3),'(i1)') kringj

* graphic initialize
      call grfini

      do ijk=1,10
        open(51,file=cfname,form='unformatted')
        read(51) kkring, kring, dlambd, dqjump(1)

        do it=0,ntstep
          read(51) dtime, nnode, dx
          if(kringj .eq. 1) then
            call anim1(kring, dtime, nnode, dx, dlambd, dqjump(1))
          else
            call anim2(kring, dtime, nnode, dx)
          end if
        end do
        close(51)
      end do

      call grfcls

      stop
      end
********************************************************************************
