!******************************************************************************
! $BI=Bj(B $BCO5eN.BNNO3X(B $B7W;;5!<B83=8(B
!
!     K-dV$BJ}Dx(B
!     $B=i4|CM(B $BAP6J@~4X?t$N>l9g(B:$B6KBgCM$N50@W$rIA$/(B
!
! $BMzNr(B 01/02/16 $BD9C+@n<B;R(B 
!      01// $BM>ED(B $B@.CK(B
!*****************************************************************************
program eq_KdV_Max2
  integer,parameter :: imax=10, jmax=200, intgrph=50, nmmax=100
  real,   parameter :: dt=0.00002
  integer :: imaxu(imax), n
  real    :: tgrph(imax*nmmax), maxugrph(imax*nmmax)
  real :: t,dx
 !
  dx = 1./jmax
 !
  write(*,*)'device number?'
  call sgpwsn
  read (*,*) iws
  call gropn(iws)
  call uzfact(0.8)
 !
  open(1,file='eq_KdV_Max2.data')
  nn = 0
  do i=0,nmmax-1
    read(1,*) t, imaxu
  ! 
    n = 0
    do in = 1,imax
      if(imaxu(in)==-99)then
        n = in-1
        exit
      end if
    end do
  if(n==0) n = imax 
  maxugrph(nn+1:nn+n) = REAL(imaxu(:n))*dx
  tgrph(nn+1:nn+n) = t
  nn = nn + n
  end do
  ! 
  close(1)
  call graph
  call grcls
 !
contains
subroutine graph
  call grfrm
  call grswnd(0.,1.,0.,dt*intgrph*nmmax)
  call grsvpt(0.2,0.8,0.18,0.78)
  call grstrn(1)
  call grstrf
  call uxaxdv('t',0.1,0.5)
  call uxaxdv('b',0.1,0.5)
  call uyaxdv('l',0.01,0.05)
  call uyaxdv('r',0.01,0.05)
  call uumrk(nn,maxugrph(:nn),tgrph(:nn))
  call uxsttl('t','Trace of Maxima',0.)
  call uxsttl('b','x',0.)
  call uysttl('l','time',0.)
end subroutine graph
!
end program


