************************************************************************
*     TRANSFORM GRID TO SPECTRA                                 96/10/26
************************************************************************
      SUBROUTINE N2G2SA(LM,KM,JM,IM,G,S,W,ITJ,TJ,ITI,TI)

ccc      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION G(0:JM-1,2,0:IM/2-1)
      DIMENSION S(-LM:LM,-KM:KM)
      DIMENSION W(JM*IM)
      DIMENSION ITJ(5),TJ(JM*2),ITI(5),TI(IM*2)

      CALL FTTRUF(JM,IM,G,W,ITI,TI)

      DO K=0,KM
        CALL FTTZUF(1,JM,G(0,1,K),W,ITJ,TJ)
      END DO

      DO K=1,KM
        DO L=1,LM
          S( L, K)=G(L,1,K)
          S(-L,-K)=G(L,2,K)
          S(-L, K)=G(JM-L,1,K)
          S( L,-K)=G(JM-L,2,K)
        END DO
      END DO

      DO K=1,KM
        S(0, K)=G(0,1,K)
        S(0,-K)=G(0,2,K)
      END DO

      DO L=1,LM
        S( L,0)=G(L,1,0)
        S(-L,0)=G(L,2,0)
      END DO

      S(0,0)=G(0,1,0)

      END
