************************************************************************
* ɽ ϵήϳ ׻¸
*
*     1ήȻ
*     Burgers 
*
*  99/05/06 ߷ 
*      99/05/12 ; 
************************************************************************
      program euler2

      parameter(imax=200,nmax=30) ! imax: åɿ, nmax: ֤ɽ 
      parameter(dt=1.0,istep=5)   ! dt: ֹ(=tend-t), istep: ƥå׿
      parameter(xmin=0.,xmax=200.,umin=-0.1,umax=5.)

      real u(0:imax,0:nmax),uw(0:imax),x(0:imax)
      real work(0:imax,3)
      character cdummy*60,ctime*6

      common /const/dx, rnu
      external odrkg, fcn
*-----+--1---------2---------3---------4---------5---------6---------7-+
      dx = (xmax-xmin)/imax  ! dx: åɹ
      tap = 0.

* ¸ѥ᡼ɤ߹
      open(1,file='expar2.data')
      read(1,*) ijk,     ! (1: 2:ƥå 3:)
     +          amp,     ! ͤ礭()
     +          rnu,     ! Ȼ
     +          cdummy
      close(1)

* ͤ
      call rset(u, imax+1, 1, tap)
      if(ijk .eq. 1) then
*--     ؿ
        do i=0,imax/2
          u(i,0) = tap + 0.5*amp*(- cos(2.*3.141592*i/(imax/2)) + 1.)
	end do
      else if(ijk .eq. 2) then
*--     ƥå״ؿ
        do i=imax/8+1,imax*3/8
          u(i,0) = tap + amp
	end do
      else if(ijk .eq. 3) then
*--     󷿴ؿ
	do i=imax/8+1,imax/4
	  u(i,0) = tap +       8.*amp*(i-imax/8)/imax
	end do
	do i=imax/4+1,imax*3/8
	  u(i,0) = tap + amp - 8.*amp*(i-imax/4)/imax
	end do
      else 
	write(6,*)'ֹ(1,2,3)'
	stop
      end if
      u(imax,0) = u(0,0)

      do i=0,imax
        x (i) = dx*i
        uw(i) = u(i,0)
      end do

* ʬ
      t=0.0
      do n=1,nmax
	tend = t + dt
	call odrkdu(imax+1, odrkg, fcn, t, tend, istep, uw, work)
	do i=0,imax
	  u(i,n) = uw(i)
	end do
      end do

* ե
      call swiset('iwidth',  750)
      call swiset('iheight', 450)
      call swlset('lalt', .true.)
      call swlset('lwait',.false.)
      call sglset('lcorner',.false.)
      call sglset('lclip',.true.)
      call sglset('lfull',.true.)

      call gropn(1)

* ˥
      do n=0,nmax
	call grfrm
	call grswnd(xmin, xmax, umin, umax)
	call grsvpt(0.15, 0.95, 0.10, 0.50)
	call grstrn(1)
	call grstrf

        if(n .ne. 0) then
          call sgspli(81)
          do npast=0,n-1
            call sgplu(imax+1, x(0), u(0,npast))
          end do  
        end if  

        call sgspli(21)
        call sgplu(imax+1, x(0), u(0,n))
	call uxaxdv('b', 10., 50.)
	call uxaxdv('t', 10., 50.) 
	call uxsttl('b', 'X', 0.0)
	call uyaxdv('l', 0.5, 1.0)
	call uyaxdv('r', 0.5, 1.0) 
	call uysttl('l', 'U', 0.0)

	ctime = 'T='
	write(ctime(3:6),'(f4.1)') n*dt
	call uxsttl('t', ctime, -0.8)
      end do

      call grcls

      end
***********************************************************************
      subroutine fcn(kmax, t, u, du)

      parameter(imax=200)          ! imax: åɿ
      real u(0:imax),du(0:imax)
      real uu(0:imax)              ! uu(i)=u(i+1/2)
      real ff(0:imax)              ! ff(i)=f(i+1/2)

      common /const/dx, rnu
*-----+--1---------2---------3---------4---------5---------6---------7-+
      uu(0) = u(0)
     &       - (u(2) - u(1)* 8 + u(imax-1)* 8 - u(imax-2)          )/24
     &       - (u(2) - u(1)*16 - u(imax-1)*16 + u(imax-2) + u(0)*30)/96
     &       + (u(2) - u(1)* 2 + u(imax-1)* 2 - u(imax-2)          )/96
     &       + (u(2) - u(1)* 4 - u(imax-1)* 4 + u(imax-2) + u(0)* 6)/384
      uu(1) = u(1)
     &       - (u(3) - u(2)* 8 + u(0)* 8 - u(imax-1)          )/24
     &       - (u(3) - u(2)*16 - u(0)*16 + u(imax-1) + u(1)*30)/96
     &       + (u(3) - u(2)* 2 + u(0)* 2 - u(imax-1)          )/96
     &       + (u(3) - u(2)* 4 - u(0)* 4 + u(imax-1) + u(1)* 6)/384

      do i=2,imax-2
        uu(i) = u(i)
     &       - (u(i+2) - u(i+1)* 8 + u(i-1)* 8 - u(i-2)          )/24
     &       - (u(i+2) - u(i+1)*16 - u(i-1)*16 + u(i-2) + u(i)*30)/96
     &       + (u(i+2) - u(i+1)* 2 + u(i-1)* 2 - u(i-2)          )/96
     &       + (u(i+2) - u(i+1)* 4 - u(i-1)* 4 + u(i-2) + u(i)* 6)/384
      end do

      uu(imax-1) = u(imax-1)
     &       - (u(1) - u(0)* 8 + u(imax-2)* 8 - u(imax-3)        )/24
     &       - (u(1) - u(0)*16 - u(imax-2)*16 + u(imax-3)
     &                                             + u(imax-1)*30)/96
     &       + (u(1) - u(0)* 2 + u(imax-2)* 2 - u(imax-3)        )/96
     &       + (u(1) - u(0)* 4 - u(imax-2)* 4 + u(imax-3)
     &                                             + u(imax-1)* 6)/384
      uu(imax) = uu(0)

      ff(0) = 0.5*uu(0)**2
     &       + rnu*(uu(2) - uu(1)*8 + uu(imax-1)*8 - uu(imax-2))/(12*dx)
      ff(1) = 0.5*uu(1)**2 
     &       + rnu*(uu(3) - uu(2)*8 + uu(0     )*8 - uu(imax-1))/(12*dx)

      do i=2,imax-2
        ff(i) = 0.5*uu(i)**2 
     &       + rnu*(uu(i+2) - uu(i+1)*8 + uu(i-1)*8 - uu(i-2))/(12*dx)
      end do

      ff(imax-1) = 0.5*uu(imax-1)**2
     &       + rnu*(uu(1) - uu(0)*8 + uu(imax-2)*8 - uu(imax-3))/(12*dx)
      ff(imax)=ff(0)

      do i=1,imax
        du(i) = - (ff(i) - ff(i-1)) / dx
      end do
      du(0) = du(imax)

      return
      end
********************************************************************************
