********************************************************************************
* ɽ ϵήϳ ׻¸
*
*      (Lorenz, 1963)
*
*  99/06/21  ⹰
*      99/06/23 ;  
********************************************************************************
      subroutine g3dini(xmin, xmax, ymin, ymax, zmin, zmax,
     +                  vxmi, vxma, vymi, vyma, vzmi, vzma,
     +                  xeye, yeye, zeye, xobj, yobj, zobj)

      real uxyma(2),uxymi(4),uzma(2),uzmi(3)

      data uxyma/-20.,  20./
      data uxymi/-30., -10., 10., 30./
      data  uzma/ 20.,  40./
      data  uzmi/ 10.,  30., 50./
*-----+--1---------2---------3---------4---------5---------6---------7-+
*X-Y
      call sgswnd(xmin, xmax, ymin, ymax)
      call sgsvpt(vxmi, vxma, vymi, vyma)
      call sgstrn(1)
      call scspln(1, 2, vzmi)
      call scseye(xeye, yeye, zeye)
      call scsobj(xobj, yobj, zobj)
      call scsprj
      
      call uzrset('uxuser',0.)
      call uzrset('uyuser',0.)
      call uziset('inner', -1)
      call uxaxnm('u', uxymi, 4, uxyma,2)
      call uyaxnm('u', uxymi, 4, uxyma,2)

      call uxsttl('t', 'Y', 0.)
      call uziset('irotcyr',0)
      call uysttl('r', 'X', 0.)

      call sglset('lprop',  .false.)
      call sgrset('const',  0.02)
      call sgrset('angle',  10.)
      call sglau(xmin,   0.0, xmax,   0.0)
      call sglau(  0.0, ymin,   0.0, ymax)

*Y-Z
      call sgswnd(ymin, ymax, zmin, zmax)
      call sgsvpt(vymi, vyma, vzmi, vzma)
      call sgstrn(1)

      call scspln(1, 3, 0.0)
      call scsprj

      call uzinit
      call uzrset('uxuser',  0.)
      call uziset('irotlyu', 0)
      call uyaxnm('u', uzmi, 3, uzma, 2)
      call uziset('irotcxt', 0)
      call uxsttl('t', 'Z', 0.)

      call sglau(0.0, zmin, 0.0, zmax)

*3-D
      call scswnd(xmin, xmax, ymin, ymax, zmin, zmax)
      call scsvpt(vxmi, vxma, vymi, vyma, vzmi, vzma)
      call scstrn(1)
      call scstrf

      return
      end
********************************************************************************


