********************************************************************************
* ɽ ϵήϳ ׻¸
*
*     
*     1 x(n+1) = x(n)**2 - c ʬ
*
*  93/xx/yy  ʻ
*      99/07/17 ; 
********************************************************************************
      program ec2 

      implicit real*8(d)
      parameter(nmax=100,nini=1000,mmax=500)
      parameter(uxmin=0.0,uxmax=2.0,uymin=-2.0,uymax=2.0)
      parameter(axmi=0.1,axma=0.5,aymi=0.2,ayma=1.0)

      character csgi*1
*-----+--1---------2---------3---------4---------5---------6---------7-+
*      call swiset('iwidth',  720)
*      call swiset('iheight', 540)
      call sglset('lfull', .true.)
      call sglset('lclip', .true.)
      call sglset('lcntl', .true.)
      call sglset('lcorner', .false.)
      call uzfact(0.8)

* open sgks
      write(*,*) ' workstation id (i) ? ;'
      call sgpwsn
      read(*,*) iws
 
      call gropn( iws )

* give constants
      dx0 = 0.d0
      call sgstxs(0.007)

      call grfrm
      call grswnd(uxmin,uxmax,uymin,uymax)
      call grsvpt( 0.10, 0.95, 0.10, 0.65)
      call grstrn(1)
      call grstrf

      call uxaxdv('b', axmi, axma)
      call uxaxdv('t', axmi, axma)
      call uyaxdv('l', aymi, ayma)
      call uyaxdv('r', aymi, ayma)
      call uxmttl('t', 'Bifurcation Diagram', 0.0)
      call uxsttl('b', 'c', 0.0)
      call uysttl('l', 'X_n"', 0.0)

* for 0<c<2
*      call sgstxi(41)
      do m=0,mmax
        dc = 2.d0 * m/mmax
        dx = dx0
        do n=1,nini
          dx = dx**2 - dc
        end do

        c = dc
        do n=1,nmax
          dx = dx**2 - dc
          x = dx
          call sgtxu(c, x, csgi(1))
        end do
      end do

      call grcls

      stop
      end
********************************************************************************
