********************************************************************************
* ɽ ϵήϳ ׻¸
*
*     
*     1 x(n+1) = x(n)**2 - c 
*     λȯŸ
*
*  93/xx/yy  ʻ
*      99/07/17 ; 
********************************************************************************
      program ec3

      implicit real*8(d)
      parameter(nmax=50)
      parameter(xmin=-2.2,xmax=2.2,emax=1.e1)

      dimension x1(0:nmax),x2(0:nmax),sa(0:nmax),rn(0:nmax)

      character cx*7,cc*5,csgi*1,cdummy*60
*-----+--1---------2---------3---------4---------5---------6---------7-+
* give constants
      open (1,file='expar1.data')
      read (1,*) dc, dx0, dxdel, cdummy
      close(1)

      dx1 = dx0
      dx2 = dx0 + dxdel
      emin= 0.1*dxdel

* calculation
      x1(0) = dx1
      x2(0) = dx2
      sa(0) = abs(dx2 - dx1)
      do n=1,nmax
        dx1   = dx1**2 - dc
        dx2   = dx2**2 - dc
        x1(n) = dx1
        x2(n) = dx2
        sa(n) = abs(dx2 - dx1)
        rn(n) = n
      end do

* figure
      call swiset('iwidth',  720)
      call swiset('iheight', 540)
      call sglset('lfull', .true.)
      call sglset('lcntl', .true.)
      call sglset('lcorner', .false.)
      call uzfact(0.8)

      call gropn(1)

* fig 1
      call grfrm
      call grswnd(rn(0), rn(nmax), xmin, xmax)
      call grsvpt( 0.15,     0.95, 0.40, 0.67)
      call grstrn(1)
      call grstrf

      axmi =  1.
      axma = 10.
      call uzlset('labelxb', .false.)
      call uxaxdv('b', axmi, axma)
      call uzlset('labelxb', .true.)
      call uxaxdv('t', axmi, axma)
      call uxsttl('t', ' ', -0.8)
      write(cc,'(f5.3)') dc
      call uxsttl('t', 'c = '//cc, -0.8)
      ayma = 1.
      aymi = 0.5
      call uyaxdv('l', aymi, ayma)
      call uyaxdv('r', aymi, ayma)
      call uysttl('l', 'X_n"', 0.0)
* x1
      call sgslni(22)
      call sglnu(2.0, 2.5, 10.0, 2.5)
      write(cx,'(f7.5)') x1(0)
      call sgstxs(0.02)
      call sgstxi(2)
      call sgstxc(-1)
      call sgtxu(10.5, 2.5, 'x_0"='//cx)

      call sgspli(22)
      call sgplu(nmax+1, rn, x1)
* x2
      call sgslni(42)
      call sglnu(27.0, 2.5, 35.0, 2.5)
      write(cx,'(f7.5)') x2(0)
      call sgtxu(35.5, 2.5, 'x_0"='//cx)

      call sgspli(42)
      call sgplu(nmax+1, rn, x2)

* fig2
      call grfig
      call grswnd(rn(0), rn(nmax), emin, emax)
      call grsvpt( 0.15,     0.95, 0.10, 0.37)
      call grstrn(2)
      call grstrf

      call uxaxdv('b', axmi, axma)
      call uxaxdv('t', axmi, axma)
      call ulylog('l', 1, 9)
      call ulylog('r', 1, 9)
      call uxsttl('b', 'n', 0.0)
      call uysttl('l', csgi(136)//'DIFFERENCE'//csgi(136), 0.0)

      call sglset('lclip', .true.)

      call sgspli(32)
      call sgplu(nmax+1, rn, sa)

      call grcls

      stop
      end
*******************************************************************************
