********************************************************************************
* ɽ ϵήϳ ׻¸
*
*     
*     1 x(n+1) = x(n)**2 - c
*     󥵥֥Ĺ
*
*  93/xx/yy  ʻ
*      99/07/17 ; 
********************************************************************************
      program ec4

      implicit real*8(d)
      parameter(nmax=50,isampl=10000,isdel=100)
      parameter(emax=1.e1)

      dimension dxinit(isampl),dif(0:nmax)
      real x(0:nmax),y(0:nmax),rdif(0:nmax)
      character cc*5,cisa*6,csgi*1,cdummy*60
*-----+--1---------2---------3---------4---------5---------6---------7-+
      open (1,file='expar1.data')
      read (1,*) dc, dx0, dxdel, cdummy
      close(1)

      emin= 0.1*dxdel

      do n=0,nmax
        dif(n) = 1.d0
          x(n) = n
      end do 

* initial values
      dxinit(1) = dx0
      do i=2,isampl
        dxinit(i) = dxinit(i-1)**2 - dc
      end do

      call swiset('iwidth',  540)
      call swiset('iheight', 540)
      call sglset('lclip', .true.)
      call sglset('lcntl', .true.)
      call sglset('lcorner', .false.)

      call gropn(1)

      call grfrm
      call grswnd( 0.0, 1.*nmax, emin, emax)
      call grsvpt(0.15,    0.95,  0.1,  0.9)
      call grstrn(2)
      call grstrf

      call uxaxdv('b', 1., 10.)
      call uxaxdv('t', 1., 10.)
      call ulylog('l', 1, 9)
      call ulylog('r', 1, 9)
      call uxsttl('b', 'n', 0.0)
      call uysttl('l', csgi(136)//'DIFFERENCE'//csgi(136), 0.0)
      write(cisa,'(i6)') isampl
      call uxsttl( 'T',cisa//'samples', 0.8)
      write(cc,'(f5.3)') dc
      call uxsttl('t','c = '//cc, -0.8)

      call sgspli(91)
* sampling ISAMPL times
      do i=1,isampl
        dx = dxinit(i)
        dy = dxinit(i) + dxdel
        do n=0,nmax
          dif(n) = dif(n) * abs(dx-dy)**(1.d0/isampl)
            y(n) = abs(dx-dy)
          dx = dx**2 - dc
          dy = dy**2 - dc
        end do

        if(mod(i,isdel) .eq. 1) call sgplu(nmax+1, x, y)
      end do

      do n=0,nmax
        rdif(n) = dif(n)
      end do

      call sgspli(42)
      call sgplu(nmax+1, x, rdif)

      call uzlset('labelxb', .false.)
      call uxaxdv('b', 1., 10.)
      call uxaxdv('t', 1., 10.)
      call uzlset('labelyl', .false.)
      call ulylog('l', 1, 9)
      call ulylog('r', 1, 9)

      call grcls

      stop
      end
*******************************************************************************
