*----------------------------------------------------------------------
*     եåν
*----------------------------------------------------------------------
      subroutine grfini(rlngth, rdr, u, v, h)

      include 'incpa.f'

ccc      parameter(ntone=18,ipat0=20,idlev=4) ! , ֹν, ʬ
ccc      parameter(ntone=35,ipat0=20,idlev=2) ! , ֹν, ʬ
      parameter(ntone=69,ipat0=21,idlev=1)    ! , ֹν, ʬ

      real u(iimax,jimax),v(iimax,jimax),h(iimax,jimax)
      real rbar(ntone+1,2)                    ! 顼С
      character ctime*4,csgi*1

      save
*-----+--1---------2---------3---------4---------5---------6---------7-+
      call glrget('rmiss',   rmiss)
      call swiset('iwidth',  540)
      call swiset('iheight', 540)
      call swlset('lwait',  .false.)
      call swlset('lalt',   .true.)
      call sglset('lcorner',.false.)
      call sglset('lcntl',  .true.)
      call sglset('lclip',  .true.)

      call gropn(1)

      call udlset('lmsg', .false.)

c**** setup for uzpack ****c
      call uzrget('rsizel1', rsizel1)

      xymin = 0.                     ! (x,y)ɸκǾ,  [x 10^3 km]
      xymax = rlngth/1.e6
      dr    = abs(rdr)/1.e6          ! ѷȾ¤ñ [x 10^3 km]
      rrdr  = rdr
      axyma = (xymax-xymin)/2.
      axymi = axyma/4.

c**** setup for uepack ****c
      rgmax = rmax(h, iimax*jimax, 1)
c      write(*,*) rgmax
      if(rgmax .eq. 0.0) rgmax = 1./3.
      rgmin = - rgmax/2.
      dlev = (rgmax-rgmin)/(ntone-2)
      rbmin = rgmin + dlev

      call gnle(rgmin, bxmin, ipmin)
      call gnle(rgmax, bxmax, ipmax)
      if(ipmin .le. -4) then
        iof = 2
      else if(ipmax .le. -4) then
        iof = 4
      else
        iof = 3
      end if

      do i=1,ntone
        ipat = (ipat0 + (i-1)*idlev)*1000 + 999
        tlev1 = rbmin + (i-iof)*dlev
        tlev2 = tlev1 + dlev
        rbar(i,1) = tlev1
        rbar(i,2) = tlev1

        if(i .eq.     1) tlev1 = rmiss
        if(i .eq. ntone) tlev2 = rmiss
        call uestlv(tlev1, tlev2, ipat)
      end do
      rbar(ntone+1,1) = rbar(ntone,1) + dlev
      rbar(ntone+1,2) = rbar(ntone,1) + dlev

      dxma = (rgmax-rgmin)/2
      dxmi = dxma/2

c**** setup for ugpack ****c
      call ugiset('index', 1)
      call uglset('lnrmal', .false.)
      vfact = 1.0
      call ugrset('xfact1', vfact)
      call ugrset('yfact1', vfact)
      call uglset('lmsg', .false.)

      return
*----------------------------------------------------------------------
*     ս
*----------------------------------------------------------------------
      entry grfdrw(t, u, v, h)

      call grfrm
      call grsvpt(  0.2,   0.9,  0.22,  0.92)
      call grswnd(xymin, xymax, xymin, xymax)
      call grstrn(1)
      call grstrf

      call uetonf(h, iimax, iimax, jimax)
c      call udcntr(h, iimax, iimax, jimax)

      call ugvect(u, iimax, v, iimax, iimax, jimax)

      call uxaxdv('t', axymi, axyma)
      call uxaxdv('b', axymi, axyma)
      call uxsttl('b', 'X [x10|6" m]', 0.0)
      call uyaxdv('l', axymi, axyma)
      call uyaxdv('r', axymi, axyma) 
      call uysttl('l', 'Y [x10|6" m]', 0.0)

      write(ctime,'(f4.1)') t
      call uxsttl('t','T='//ctime//' hours',1.0)

      call sglset('lclip',  .false.)
      call sgslni(2)
      call sgstxi(2)
      call sgstxs(0.02)
      xx = xymin - 0.2*xymax
      yy = xymin - 0.2*xymax
      if(rrdr .ne. rmiss) then
        call sglnu(xx, yy, xx+dr, yy)
        call sgtxu(xx,    yy, 'I')
        call sgtxu(xx+dr, yy, 'I')
      else
        call sgstxc(-1)
        call sgstxs(0.04)
        call sgtxu(xx, yy, csgi(189))
        call sgstxs(0.02)
      end if  

      call sgstxc(-1)
      yy = xymin - 0.25*xymax
      call sgtxu(xx, yy, 'Radius of deformation')
      call sgstxc(0)
      call sglset('lclip',  .true.)

*- color bar
      call grfig
      call grsvpt(     0.62,             0.9, 0.04, 0.08)
      call grswnd(rbar(1,1), rbar(ntone+1,1), 0.0,  1.)
      call grstrn(1)
      call grstrf

      call uetone(rbar, ntone+1, ntone+1, 2)
      call uzrset('rsizel1', 0.017)
      call uxaxdv('b', dxmi, dxma) 
      call uzrset('rsizel1', rsizel1)
      call uxaxdv('t', dxmi, dxma) 
      call uzlset('labelyl',.false.)
      call uyaxdv('l', 1., 1.) 
      call uzlset('labelyl',.true.)
      call uyaxdv('r', 1., 1.)
      call uxsttl('t', 'h'//csgi(178), 0.0)

      return
*----------------------------------------------------------------------
*     λ
*----------------------------------------------------------------------
      entry grfcls

      write(6,*) 'Calculation is over. Click the mouse button.'

      call grcls

      return
      end
********************************************************************************





