********************************************************************************
* ɽ ϵήϳ ׻¸
*
*     ϹήĴᡧ2
*     energy λѲ
*
* 99/07/25 ;  
********************************************************************************
      program timev

      include 'incpa.f'

      real u(iimax,jimax),v(iimax,jimax),h(iimax,jimax)
      real time(0:nmax),et(0:nmax),ek(0:nmax),ep(0:nmax)
      real etin(0:nmax),ekin(0:nmax),epin(0:nmax)
      real x(2),y(2)
*-----+--1---------2---------3---------4---------5---------6---------7-+
* open file and read initial dara
      open(50,file='adjst1.data',form='unformatted')
      read(50) g, rlngth

      do n=0,nmax
        read(50) t, u, v, h, rek, rep, rekin, repin
        time(n) = t                               ! t ñ̤ϻ
        ek(n) = rek
        ep(n) = rep
        et(n) = ek(n) + ep(n)
        ekin(n) = rekin
        epin(n) = repin
        etin(n) = ekin(n) + epin(n)
      end do

      close(50)

      emin = 0.0
      emax = rmax(et, nmax+1, 1)
      emax = rgnge(emax)
      
*       
      call swiset('iwidth', 720)
      call swiset('iheight',540)
      call sglset('lcorner',.false.)
      call sglset('lcntl',  .true.)
      call sglset('lfull',  .true.)
      call uzfact(0.75)

      call gropn(1)
      call grfrm
      call grswnd(time(0), time(nmax), emin, emax)
      call grsvpt(   0.15,       0.95, 0.10, 0.60)
      call grstrn(1)
      call grstrf

      call usdaxs
      call uxsttl('b', 'TIME[hours]', 0.0)
      call uysttl('l', 'ENERGY', 0.0)

      call sgspli(22)
      call sgplu(nmax+1, time, ek)
      call sgspli(42)
      call sgplu(nmax+1, time, ep)
      call sgspli(32)
      call sgplu(nmax+1, time, et)

      call sgstxi(2)
      call sgstxc(-1)
      call sgstxs(0.022)
      vy = 0.67
      call sgslni(22)
      call sglnv(0.20, vy, 0.30, vy)
      call sgtxv(0.31, vy, 'KE_fa"')
      call sgslni(42)
      call sglnv(0.45, vy, 0.55, vy)
      call sgtxv(0.56, vy, 'PE_fa"')
      call sgslni(32)
      call sglnv(0.70, vy, 0.80, vy)
      call sgtxv(0.81, vy, 'TE_fa"')

      call sgsplt(3)
      call sgspli(22)
      call sgplu(nmax+1, time, ekin)
      call sgspli(42)
      call sgplu(nmax+1, time, epin)
      call sgspli(32)
      call sgplu(nmax+1, time, etin)

      vy   = 0.63
      y(1) = vy
      y(2) = y(1)
      
      call sgsplt(3)
      x(1) = 0.2
      x(2) = x(1) + 0.1
      call sgspli(22)
      call sgplv(2, x, y)
      call sgtxv(0.31, vy, 'KE_in"')

      x(1) = 0.45
      x(2) = x(1) + 0.1
      call sgspli(42)
      call sgplv(2, x, y)
      call sgtxv(0.56, vy, 'PE_in"')

      x(1) = 0.7
      x(2) = x(1) + 0.1
      call sgspli(32)
      call sgplv(2, x, y)
      call sgtxv(0.81, vy, 'TE_in"')

      call grcls

      stop
      end
********************************************************************************
