*" numflx.f 1ʬοή«
*" 96/06/19 Ƿ
*" 
*" ֥롼̾κǽ2ʸ, Ĥϥ,ɽ.
*" ͤ򤤤ѤƤߤѥ᥿ϥץ -sb:rnu Ǽ
*" 褦ˤ(see KALWCC,DFFWCC etc.).
************************************************************************
*" ή f=u^2/2
*" ή()ʬ(UpStream), å
*=======================================================================
      SUBROUTINE NAUSCC
     I     (JMAX,DX,DT,UU,
     O      FF,
     W      W)
*
      DIMENSION UU(JMAX)   !" UU(J)=u_{j}
      DIMENSION FF(0:JMAX) !" FF(J)=f_{j+1/2}
*(    dimension W !" dummy )

      DO J=1,JMAX-1
        IF( (UU(J)+UU(J+1)).GE.0 ) THEN
          FF(J)=(UU(J)**2)/2
        ELSE
          FF(J)=(UU(J+1)**2)/2
        ENDIF
      ENDDO

      U0=UU(JMAX)
      IF( (U0+UU(1)).GE.0 ) THEN
        FF(0)=(U0**2)/2
      ELSE
        FF(0)=(UU(1)**2)/2
      ENDIF
      FF(JMAX)=FF(0)

      RETURN
      END
************************************************************************
*" ή f=u^2/2
*" Lax-Wendroff , å
*=======================================================================
      SUBROUTINE NALWCC
     I     (JMAX,DX,DT,UU,
     O      FF,
     W      FW)
*
      DIMENSION UU(JMAX)   !" UU(J)=u_{j}
      DIMENSION FF(0:JMAX) !" FF(J)=f_{j+1/2}
      DIMENSION FW(JMAX) !" FW(J)=f_{j}

      DTDX2=DT/DX/2

      DO J=1,JMAX
        FW(J)=(UU(J)**2)/2
      ENDDO

      DO J=1,JMAX-1
        FF(J)=(FW(J+1)+FW(J))/2
     &       - DTDX2 * (UU(J+1)+UU(J))/2 * (FW(J+1)-FW(J))
      ENDDO

      U0=UU(JMAX)
      F0=FW(JMAX)
      FF(0)=(FW(1)+F0)/2
     &       - DTDX2 * (UU(1)+U0)/2 * (FW(1)-F0)
      FF(JMAX)=FF(0)

      RETURN
      END
************************************************************************
*" ή f=u^2/2
*" ʬ(Central difference in Space), å
*=======================================================================
      SUBROUTINE NACSCC
     I     (JMAX,DX,DT,UU,
     O      FF,
     W      W)
*
      DIMENSION UU(JMAX)   !" UU(J)=u_{j}
      DIMENSION FF(0:JMAX) !" FF(J)=f_{j+1/2}
*(    dimension W !" dummy )

      DO J=1,JMAX-1
        FF(J)=(UU(J+1)**2+UU(J)**2)/4
      ENDDO

      FF(0)=(UU(1)**2+UU(JMAX)**2)/4
      FF(JMAX)=FF(0)

      RETURN
      END
************************************************************************
*" ή f=cu, c=1
*" ή()ʬ(UpStream), å
*=======================================================================
      SUBROUTINE LAUSCC
     I     (JMAX,DX,DT,UU,
     O      FF,
     W      W)
*
      DIMENSION UU(JMAX)   !" UU(J)=u_{j}
      DIMENSION FF(0:JMAX) !" FF(J)=f_{j+1/2}
*(    dimension W !" dummy )
      PARAMETER (C=1)

      DO J=1,JMAX-1
        IF( (UU(J)+UU(J+1)).GE.0 ) THEN
          FF(J)=C*UU(J)
        ELSE
          FF(J)=C*UU(J+1)
        ENDIF
      ENDDO

      U0=UU(JMAX)
      IF( (U0+UU(1)).GE.0 ) THEN
        FF(0)=C*U0
      ELSE
        FF(0)=C*UU(1)
      ENDIF
      FF(JMAX)=FF(0)

      RETURN
      END
************************************************************************
*" ή f=cu, c=1
*" Lax-Wendroff , å
*=======================================================================
      SUBROUTINE LALWCC
     I     (JMAX,DX,DT,UU,
     O      FF,
     W      FW)
*
      DIMENSION UU(JMAX)   !" UU(J)=u_{j}
      DIMENSION FF(0:JMAX) !" FF(J)=f_{j+1/2}
      DIMENSION FW(JMAX) !" FW(J)=f_{j}
      PARAMETER (C=1)

      DTDX2=DT/DX/2

      DO J=1,JMAX
        FW(J)=C*UU(J)
      ENDDO

      DO J=1,JMAX-1
        FF(J)=(FW(J+1)+FW(J))/2
     &       - DTDX2 * C * (FW(J+1)-FW(J))
      ENDDO

      F0=FW(JMAX)
      FF(0)=(FW(1)+F0)/2
     &       - DTDX2 * C * (FW(1)-F0)
      FF(JMAX)=FF(0)

      RETURN
      END
************************************************************************
*" ή f=cu, c=1
*" ʬ(Central difference in Space), å
*=======================================================================
      SUBROUTINE LACSCC
     I     (JMAX,DX,DT,UU,
     O      FF,
     W      W)
      PARAMETER (C=1)
*
      DIMENSION UU(JMAX)   !" UU(J)=u_{j}
      DIMENSION FF(0:JMAX) !" FF(J)=f_{j+1/2}
*(    dimension W !" dummy )

      DO J=1,JMAX-1
        FF(J)=C*(UU(J+1)+UU(J))/2
      ENDDO

      FF(0)=C*(UU(1)+UU(JMAX))/2
      FF(JMAX)=FF(0)

      RETURN
      END
************************************************************************
*" KdV  f = u^2/2 + ͢^2u/x^2, =const.
*" ή()ʬ(UpStream), å
*" ή塢ʬɾ
*" () Τ褦1ΥǤϿǴबʬ뤿Ŭڤ
*" ʤ.
*=======================================================================
      SUBROUTINE KAUSCC
     I     (JMAX,DX,DT,UU,
     O      FF,
     W      W)
*
      DIMENSION UU(JMAX)   !" UU(J)=u_{j}
      DIMENSION FF(0:JMAX) !" FF(J)=f_{j+1/2}
*(    dimension W !" dummy )
      LOGICAL   LFIRST
      SAVE      RNU,LFIRST
      DATA      RNU /0.015/
      DATA      LFIRST /.TRUE./

      RDX2=RNU/DX**2

      IF(LFIRST) THEN
        LFIRST=.FALSE.
        CALL RTPGET('SB:','RNU     ',RNU,1)
        WRITE(6,*) '*(֥롼KAUSCC)* KdVοflux׻'
        WRITE(6,*) '!!!! κʬˡKdV򤯤ΤŬʤ'
        WRITE(6,*) '  ʬη:     -sb:rnu=',RNU
        WRITE(6,*)
        WRITE(6,*) 'DT,DX,RNU',DT,DX,RDX2
        WRITE(6,*) 'DT/DX',DT/DX
        WRITE(6,*) '4*RNU*DT/DX^3',4*DT/DX*RDX2
      ENDIF

      DO J=2,JMAX-2
        IF( (UU(J)+UU(J+1)).GE.0 ) THEN
          FF(J)=(UU(J)**2)/2 + RDX2*(UU(J+2)-2*UU(J+1)+UU(J))
        ELSE
          FF(J)=(UU(J+1)**2)/2 + RDX2*(UU(J+1)-2*UU(J)+UU(J-1))
        ENDIF
      ENDDO

      U0=UU(JMAX)     !" UU(0)
      UM1=UU(JMAX-1)  !" UU(-1)
      IF( (U0+UU(1)).GE.0 ) THEN
        FF(0)=(U0**2)/2 + RDX2*(UU(2)-2*UU(1)+U0)
      ELSE
        FF(0)=(UU(1)**2)/2 + RDX2*(UU(1)-2*U0+UM1)
      ENDIF
      FF(JMAX)=FF(0)

      J=1
      IF( (UU(J)+UU(J+1)).GE.0 ) THEN
        FF(J)=(UU(J)**2)/2 + RDX2*(UU(J+2)-2*UU(J+1)+UU(J))
      ELSE
        FF(J)=(UU(J+1)**2)/2 + RDX2*(UU(J+1)-2*UU(J)+U0)
      ENDIF

      UM1=UU(2)  !" UU(JMAX+1)
      J=JMAX-1
      IF( (UU(J)+UU(J+1)).GE.0 ) THEN
        FF(J)=(UU(J)**2)/2 + RDX2*(UM1-2*UU(J+1)+UU(J))
      ELSE
        FF(J)=(UU(J+1)**2)/2 + RDX2*(UU(J+1)-2*UU(J)+UU(J-1))
      ENDIF

      RETURN
      END
************************************************************************
*" KdV  f = u^2/2 + ͢^2u/x^2, =const.
*" Lax-Wendroff , å
*=======================================================================
      SUBROUTINE KALWCC
     I     (JMAX,DX,DT,UU,
     O      FF,
     W      FW)
*
      DIMENSION UU(JMAX)   !" UU(J)=u_{j}
      DIMENSION FF(0:JMAX) !" FF(J)=f_{j+1/2}
      DIMENSION FW(-1:JMAX+1) !" FW(J)=f_{j}
      LOGICAL   LFIRST
      SAVE      RNU,LFIRST
      DATA      RNU /0.015/
      DATA      LFIRST /.TRUE./

      IF(LFIRST) THEN
        LFIRST=.FALSE.
        CALL RTPGET('SB:','RNU     ',RNU,1)
        WRITE(6,*)
        WRITE(6,*) '*(֥롼KALWCC)* KdVοflux׻'
        WRITE(6,*) '  ʬη:     -sb:rnu=',RNU
        WRITE(6,*)
      ENDIF

      RDX2=RNU/DX**2
      DTDX2=DT/DX/2

      DO J=2,JMAX-1
        FW(J)=(UU(J)**2)/2 + RDX2*(UU(J+1)-2*UU(J)+UU(J-1))
      ENDDO
      U0=UU(JMAX)
      FW(1)=(UU(1)**2)/2 + RDX2*(UU(2)-2*UU(1)+U0)
      FW(JMAX)=(UU(JMAX)**2)/2 + RDX2*(UU(1)-2*UU(JMAX)+UU(JMAX-1))
      FW(0)=FW(JMAX)
      FW(-1)=FW(JMAX-1)
      FW(JMAX+1)=FW(1)

      DO J=0,JMAX-1
        FF(J)=(FW(J+1)+FW(J))/2
     &       - DTDX2 * ( (UU(J+1)+UU(J))/2 * (FW(J+1)-FW(J))
     &                 + RDX2 * (FW(J+2)-3*FW(J+1)+3*FW(J)-FW(J-1)) )
      ENDDO
      FF(JMAX)=FF(0)

      RETURN
      END
************************************************************************
*" Ȼ f=͢u/x
*"  --- 2*RNU*DT/DX^2 > 1 ԰
*=======================================================================
      SUBROUTINE DFFWCC
     I     (JMAX,DX,DT,UU,
     O      FF,
     W      W)
*
      DIMENSION UU(JMAX)   !" UU(J)=u_{j}
      DIMENSION FF(0:JMAX) !" FF(J)=f_{j+1/2}
*(    dimension W !" dummy )
      LOGICAL   LFIRST
      SAVE      RNU,LFIRST
      DATA      RNU /0.02/
      DATA      LFIRST /.TRUE./

      DTDX2=DT/DX/2

      IF(LFIRST) THEN
        LFIRST=.FALSE.
        CALL RTPGET('SB:','RNU     ',RNU,1)
        WRITE(6,*) '*(֥롼DFFWCC)* Ȼοflux׻'
        WRITE(6,*) '  Ȼ:     -sb:rnu=',RNU
        WRITE(6,*) '  2*RNU*DT/DX^2',2*RNU*DT/DX**2
        WRITE(6,*)
      ENDIF

      DO J=1,JMAX-1
        FF(J)= -RNU * (UU(J+1)-UU(J)) /DX
      ENDDO

      U0=UU(JMAX)
      FF(0)= -RNU * (UU(1)-U0) /DX
      FF(JMAX)=FF(0)

      RETURN
      END
