********************************************************************************
* ɽ ϵήϳ ׻¸
*
*     ľ2ǮήΥڥȥǥ롧(Benard-Rayleigh)
*
*  95/01/28   ()
*      99/06/18     (ù)
*      99/06/20 ;  ()
********************************************************************************
      program convct

      include  'incpa.f'
      real tzmn (2*mx+1,ny,2) ! tzmn(*,*,ij): ȿ֤Ǥβ(ij=1),(ij=2)
      real ptb  (    ix,jy-1) ! ptbij: ¶֤Ǥξ
      real ptbmj(2*mx+1,jy-1)
      real ptbmn(2*mx+1,ny)   ! ptbmn: ȿ֤Ǥξ
      real work((2*mx+1)*ny*2*3)

      common /const/ra,pr
      external sublc,subnc
*-----+--1---------2---------3---------4---------5---------6---------7-+
* ¸ѥ᡼ɤ߹ߤ
      open(1,file='expar.data')
      read(1,*) ra, pr, ips, amp, sigma, dt, istep
      close(1)

* ֥롼ν
      call frini
      call grfini

* ͤ
      time = 0.0
      call rset(tzmn, (2*mx+1)*ny*2, 1, 0.0)

* 
      iptb = ix/rlengt            !Ϳ濴 x-å
      jptb = jy/2.0               !Ϳ濴 y-å
      dx = rlengt/ix
      dy = 1.0/jy
      do j=1,jy-1
        do i=1,ix
          ptb(i,j) = amp
     +              *exp(-( ((i-iptb)*dx)**2 + ((j-jptb)*dy)**2 )
     +                                          / ( 2.*sigma**2 ) )
        end do
      end do

      call  xfrf(  ptb,ptbmj)
      call ysinf(ptbmj,ptbmn)

      do n=1,ny
        do m=1,2*mx+1
          if(ips .eq. 1) then
            tzmn(m,n,1) = ptbmn(m,n)
          else if(ips .eq. 2) then
            tzmn(m,n,2) = ptbmn(m,n)
          else
            stop 'ips must be 1 or 2'
          end if
        end do
      end do

      call datopn(ra, pr)
      call datwrt(time, tzmn)     ! ǡ
      call graph (time, tzmn)     ! ս

* ȯŸ
      do i=1,imax
        call tdrknu((2*mx+1)*ny*2, istep, dt, time,
     +                             tzmn, work, sublc, subnc)
        call datwrt(time, tzmn)   ! ǡ
        call graph (time, tzmn)   ! ս
      end do

      call datcls
      call grcls
      end
********************************************************************************
*  (Ȼ)ʬη׻롼 
********************************************************************************
      subroutine sublc(time, hdt, tzmn)

      include 'incpa.f'
      real tzmn(2*mx+1,ny,2)

      common /const/ra,pr
*-----+--1---------2---------3---------4---------5---------6---------7-+
      do n=1,ny
        rll = (pi*n)**2
        tzmn(1,n,1) = tzmn(1,n,1)*exp(-rll*hdt)
        tzmn(1,n,2) = tzmn(1,n,2)*exp(-rll*hdt*pr)
        do m=1,mx
          rmn = (2*pi*m/rlengt)**2 + (pi*n)**2
          tzmn(2*m,  n,1) = tzmn(2*m,  n,1)*exp(-rmn*hdt)
          tzmn(2*m+1,n,1) = tzmn(2*m+1,n,1)*exp(-rmn*hdt)
          tzmn(2*m,  n,2) = tzmn(2*m  ,n,2)*exp(-rmn*hdt*pr)
          tzmn(2*m+1,n,2) = tzmn(2*m+1,n,2)*exp(-rmn*hdt*pr)
        end do
      end do
      end
********************************************************************************
*  ʬη׻롼
********************************************************************************
      subroutine subnc(time, tzmn, dtzmn)

      include 'incpa.f'
      real tzmn(2*mx+1,ny,2),dtzmn(2*mx+1,ny,2)
      real u(ix,jy-1),v(ix,jy-1),dtdx(ix,jy-1),dtdy(ix,jy-1)
      real a(ix,jy-1),b(ix,jy-1),dzdx(ix,jy-1),dzdy(ix,jy-1)
      real fmj(2*mx+1,jy-1)
      real amn(2*mx+1,ny),bmn(2*mx+1,ny),fmn(2*mx+1,ny)

      common /const/ra,pr
*-----+--1---------2---------3---------4---------5---------6---------7-+
*--- u(x,y) ---
      call mncopy(tzmn(1,1,2), fmn)
      call laplab(fmn)
      call dfmndy(fmn)
      call  ycosb(fmn, fmj)
      call   xfrb(fmj, u)
      call rmlt(u, ix*(jy-1), 1, -1.0)
*--- v(x,y) ---
      call mncopy(tzmn(1,1,2), fmn)
      call laplab(fmn)
      call  ysinb(fmn, fmj)
      call dfmjdx(fmj)
      call   xfrb(fmj, v)
*--- dT(x,y)/dx ---
      call mncopy(tzmn(1,1,1), fmn)
      call  ysinb(fmn, fmj)
      call dfmjdx(fmj)
      call   xfrb(fmj, dtdx)
*--- dT(x,y)/dy ---
      call mncopy(tzmn(1,1,1), fmn)
      call dfmndy(fmn)
      call  ycosb(fmn, fmj)
      call   xfrb(fmj, dtdy)
      call radd(dtdy, ix*(jy-1), 1, -1.0)
*--- dZ(x,y)/dx ---
      call mncopy(tzmn(1,1,2), fmn)
      call  ysinb(fmn, fmj)
      call dfmjdx(fmj)
      call   xfrb(fmj, dzdx)
*--- dZ(x,y)/dy ---
      call mncopy(tzmn(1,1,2), fmn)
      call dfmndy(fmn)
      call  ycosb(fmn, fmj)
      call   xfrb(fmj, dzdy)

* η׻
      do j=1,jy-1
        do i=1,ix
          a(i,j) = u(i,j)*dtdx(i,j) + v(i,j)*dtdy(i,j)
          b(i,j) = u(i,j)*dzdx(i,j) + v(i,j)*dzdy(i,j)
        end do
      end do

      call  xfrf(  a, fmj)
      call ysinf(fmj, amn)
      call  xfrf(  b, fmj)
      call ysinf(fmj, bmn)

* ʬη׻
      do n=1,ny
        dtzmn(1,n,1) = - amn(1,n)
        dtzmn(1,n,2) = - bmn(1,n)
        do m=1,mx
          rmn = (2*pi*m/rlengt)**2 + (pi*n)**2
          dtzmn(2*m,  n,1) = - amn(2*m,  n)
          dtzmn(2*m+1,n,1) = - amn(2*m+1,n)
          dtzmn(2*m,  n,2) = - bmn(2*m,  n)
     +                     + (- 2*pi*m*ra*tzmn(2*m+1,n,1)/rlengt)*pr
          dtzmn(2*m+1,n,2) = - bmn(2*m+1,n)
     +                     + (  2*pi*m*ra*tzmn(2*m,  n,1)/rlengt)*pr
        end do
      end do

      return
      end
********************************************************************************
*                    ǡν񤭹ߥ롼 
********************************************************************************
      subroutine datopn(ra, pr)

      include  'incpa.f'
      real tzmn(2*mx+1,ny,2)
*-----+--1---------2---------3---------4---------5---------6---------7-+
* եΥץȥإå񤭹
      open (61, file='convct.data', form='unformatted' )
      write(61) ra, pr

      return
*-------------------------------------------------------------------------------
      entry datwrt(time, tzmn)

* ǡν񤭹
      write(61) time, tzmn

      return
*-------------------------------------------------------------------------------
      entry datcls

* եΥʤ
      close(61)
      write(6,*) 'Calculation is over. Click the mouse button.'

      return
      end
*******************************************************************************



