********************************************************************************
* ɽ ϵήϳ ׻¸
*
*     ľ2ǮήΥڥȥǥ롧(Benard-Rayleigh)
*
*  95/01/28   ()
*      99/05/25     (ù)
*      99/05/30 ;  ()
********************************************************************************
*     եϢ֥롼
********************************************************************************
      subroutine grfini

*--- 롼 ---
      include 'incpa.f'
      parameter(vxmin=0.28,vxmax=0.96)         ! ӥ塼ݡȤ x ɸ
      parameter(vydel=(vxmax-vxmin)/rlengt)
      parameter(vymin=0.18,vymax=vymin+vydel)   ! ӥ塼ݡȤ y ɸ
cc      parameter(ntone=18,ipat0=20,idlev=4)      ! , ֹν, ʬ
cc      parameter(ntone=35,ipat0=20,idlev=2)      ! , ֹν, ʬ
      parameter(ntone=69,ipat0=21,idlev=1)      ! , ֹν, ʬ

      real tzmn(2*mx+1,ny,2),tmj(2*mx+1,jy-1),t(ix,jy-1)
      real  pmn(2*mx+1,ny),  pmj(2*mx+1,jy-1),p(ix,jy-1)
      real u(ix,jy-1),v(ix,jy-1)
      real tgr(0:ix,0:jy),tbar(0:jy),y(0:jy)
      real pgr(0:ix,0:jy)
      real ugr(0:ix,0:jy),vgr(0:ix,0:jy)
      real rbar(ntone,2)                        ! 顼С
      character ct*10,ctime*10
      save dx, dy, y

      common /const/ra,pr
*-----+--1---------2---------3---------4---------5---------6---------7-+
      dx = rlengt/ix
      dy =    1.0/jy
      do j=0,jy
        y(j) = j*dy
      end do

* dcl
      call gllset('lmiss',  .true.)
      call glrget('rmiss',   rmiss)
      call swiset('iwidth',  720)
      if(rlengt .ge. 4.) then
        call swiset('iheight', 320)
      else if(rlengt .ge. 2.) then
        call swiset('iheight', 440)
      else
        call swiset('iheight', 540)
      end if  
      call swlset('lwait',  .false.)
      call swlset('lalt',   .true.)
      call sglset('lcorner',.false.)
      call sglset('lfull',  .true.)      
      call gropn(1)
      call uzfact(0.75)

* udpack 
      call udlset('lmsg',  .false.)
      call udsfmt('(i3)')
      call udiset('indxmj', 991)
      call udiset('indxmn', 991)
      call udiset('icycle',   2)
      call udrset('rsizel', 0.012)
      call udgcla(-30., 30., 2.5)

* uepack 
      rgmin = 0.0
      rgmax = 1.0
      do i=1,ntone
        rbar(i,1) = rgmin + (rgmax-rgmin)*(i-1)/(ntone-1)
        rbar(i,2) = rbar(i,1)
      end do
      dtma = (rgmax-rgmin)/2
      dtmi = dtma/2

      dlev = (rgmax-rgmin)/ntone
      do i=1,ntone
        ipat = (ipat0 + (i-1)*idlev)*1000 + 999
        tlev1 = rgmin + (i-1)*dlev
        tlev2 = tlev1 + dlev
        if(i .eq.     1) tlev1 = rmiss
        if(i .eq. ntone) tlev2 = rmiss
        call uestlv(tlev1, tlev2, ipat)
      end do

* ugpack 
      call uglset('lnrmal',.false.)
      call uglset('lmsg',  .false.)
      call ugiset('index',  991)
      vfact = 0.0001
      call ugrset('xfact1', vfact)
      call ugrset('yfact1', vfact)

* uzpack 
      axmi = 0.1
      axma = 0.5
  
      return
********************************************************************************
*--- 롼 ---
      entry graph(time, tzmn)

      call mncopy(tzmn(1,1,2), pmn) ! ®پ
      call laplab(pmn)
      call ysinb(pmn, pmj)
      call ysinb (tzmn(1,1,1), tmj) ! پ

*--- xʿ ---
      do j=1,jy-1
        tbar(j) = tmj(1,j) - j*dy + 1.0
      end do
      tbar( 0) = 1.0
      tbar(jy) = 0.0
*--- T(x,y) ---
      call xfrb(pmj, p)
      call xfrb(tmj, t)
      do j=1,jy-1
        do i=1,ix
          pgr(i,j) = p(i,j)
          tgr(i,j) = t(i,j) - j*dy + 1.0
        end do
      end do
      do i=0,ix
        pgr(i, 0) = 0.0
        pgr(i,jy) = 0.0
        tgr(i, 0) = 1.0
        tgr(i,jy) = 0.0
      end do
      do j=1,jy-1
        pgr(0,j) = pgr(ix,j)
        tgr(0,j) = tgr(ix,j)
      end do

*--- u(x,y) ---
      call dfmndy(pmn)
      call  ycosb(pmn, pmj)
      call   xfrb(pmj, u)
      call rmlt(u, ix*(jy-1), 1, -1.0)
*--- v(x,y) ---
      call  ysinb(pmn, pmj)
      call dfmjdx(pmj)
      call   xfrb(pmj, v)

      do j=1,jy-1
        do i=1,ix
          ugr(i,j) = u(i,j)
          vgr(i,j) = v(i,j)
        end do
        ugr(0,j) = u(ix,j)
        vgr(0,j) = v(ix,j)
      end do

      do i=0,ix
        ugr(i, 0) = rmiss
        vgr(i,jy) = rmiss
      end do

* xʿѲ٤ι⤵ʬ
      call grfrm
      call grswnd( 0.0,  1.0,   0.0,   1.0)
      call grsvpt(0.12, 0.25, vymin, vymax)
      call grstrn(1)
      call grstrf

      call sgspli( 22 )
      call sgplu(jy+1, tbar, y)

      call uxaxdv('b', 0.25, 0.5)
      call uyaxdv('l', axmi, axma)
      call uxsttl('b','[T]',0.0)
      call uysttl('l','HEIGHT',0.0)
      write(ct,'(e6.1)') pr
      call uxsttl('t', 'Pr# = '//ct, -1.0)
      write(ct,'(e6.1)') ra 
      call uxsttl('t', 'Ra# = '//ct, -1.0)

* پ®پ
      call grfig
      call grswnd(  0.0, rlengt,   0.0,   1.0)
      call grsvpt(vxmin,  vxmax, vymin, vymax)
      call grstrn(1)
      call grstrf

      call uetonf(tgr, ix+1, ix+1, jy+1)
cc      call uetone(tgr, ix+1, ix+1, jy+1)
      if(jy .le.32) call udcntr(pgr, ix+1, ix+1, jy+1)
cc      call ugvect(ugr, ix+1, vgr, ix+1, ix+1, jy+1)

      call uxaxdv('b', axmi, axma)
      call uxaxdv('t', axmi, axma)
      call uzlset('labelyl',.false.)
      call uyaxdv('l', axmi, axma)
      call uyaxdv('r', axmi, axma)
      call uzlset('labelyl',.true.)
      call uxsttl('b','WIDTH',0.0)
      write(ctime,'(f7.3)') time
      call uxmttl('t', 'TIME = '//ctime, 0.8)

*- color bar
      call grfig
      call grsvpt(0.7, vxmax, 0.07, 0.11)
      call grswnd( 0.0,  1.0,  0.0,  1.0)
      call grstrn(1)
      call grstrf

      call uetone(rbar, ntone, ntone, 2)
      call uxaxdv('b', dtmi, dtma) 
      call uxaxdv('t', dtmi, dtma) 
      call uzlset('labelyl',.false.)
      call uyaxdv('l', 1., 1.)
      call uzlset('labelyl',.true.)
      call uyaxdv('r', 1., 1.) 
      call uxsttl('b', 'Temperature', 0.0)

      return
      end
********************************************************************************

