********************************************************************************
* ɽ ϵήϳ ׻¸
*
*     ѡˡ(2) ư
*
*  99/06/06 ; 
********************************************************************************
      program inert1

      parameter(pi=3.1416)
      parameter(xmin=-500.,xmax=500.,ymin=-500.,ymax=500.)
      parameter(mmax=1)                           ! mmax: ɽ¸
      parameter(nmax=200)                         ! nmax: ֥ƥå׿
                                                  ! ֤ñ̤ [day]
      real   x(0:nmax),  y(0:nmax)                ! žϡĹñ̤ [km]
      real  xi(0:nmax), yi(0:nmax)                ! ϡĹñ̤ [km]
      real xi0(0:nmax),yi0(0:nmax)                ! ϡĹñ̤ [km]
      character csgi*1,cdummy*60,cphi*8,ctime*20, ct*20
*-----+--1---------2---------3---------4---------5---------6---------7-+
* ¸ѥ᡼ɤ߹
      open(1,file='expar1.data')
      read(1,*) phi, x0, y0, u0, v0, cdummy 
      close(1)

      f  = 2. * (2*pi) * sin(phi*pi/180)
      dt = 1. / sin(phi*pi/180) /100

* ñ̤ѹ s => day, m => km
      u0 = u0*86400/1000                    ! (u,v) ñ̤[km/day]
      v0 = v0*86400/1000

* ȯŸ
      do n=0,nmax
        t=dt*n
        call integ(f, x0, y0, u0, v0, t, 
     +             x(n), y(n), xi(n), yi(n), xi0(n), yi0(n))
      end do
  
* graphic initialize
      call swiset('iwidth',  720)
      call swiset('iheight', 480)
      call swlset('lalt', .true.)
      call swlset('lwait',.false.)
      call sglset('lcorner',.false.)
      call sglset('lclip',.true.)
      call sglset('lfull',.true.)
      call sglset('lprop', .false.)
      call sgrset('const', 0.015)
      call uzfact(0.85)

      call gropn(1)
* animation
      cphi = 'Lat=????'
      write(cphi(5:8),'(f4.1)') phi
      ct = cphi // '|' // csgi(4) // '"'
      
      do n=0,nmax
        time  = n*dt
        theta = f*time
	ctime = 'T=????? days      '
	write(ctime(3:7),'(f5.2)') time

* rotating frame
	call grfrm
        call grswnd(xmin, xmax, ymin, ymax)
        call grsvpt(0.13, 0.48, 0.12, 0.47)
        call grstrn(1)
        call grstrf

        call uxaxdv('b', 100., 500.)
        call uxaxdv('t', 100., 500.) 
        call uyaxdv('l', 100., 500.)
        call uyaxdv('r', 100., 500.) 
        
        call uxmttl('t', ctime, -1.0)
        call uxsttl('t', ct, -1.0)
        call uxsttl('b', 'X [km]', 0.0)
        call uysttl('l', 'Y [km]', 0.0)

        call sgslai(31)
        call sglau(xmin,  0.0, xmax,  0.0)
        call sgslai(41)
        call sglau( 0.0, ymin,  0.0, ymax)

        call sgspmi(41)
        call sgspmt(5)
        call sgpmu(1, x(0), y(0))

        call sgspli(81)
        if(n .ne. 0) then
          call sgplu(n+1, x, y)
        end if
        
        call sgspmi(21)
        call sgspmt(230)
        call sgpmu(1, x(n), y(n))

* inertial frame
	call grfig
        call grswnd(xmin, xmax, ymin, ymax)
        call grsvpt(0.64, 0.99, 0.12, 0.47)
        call grstrn(1)
        call grstrf

        call uxaxdv('b', 100., 500.)
        call uxaxdv('t', 100., 500.) 
        call uyaxdv('l', 100., 500.)
        call uyaxdv('r', 100., 500.) 
        
        call uxsttl('b', 'X-inertial [km]', 0.0)
        call uysttl('l', 'Y-inertial [km]', 0.0)

        xaxpx =  xmax*cos(0.5*theta)
        xaxpy =  xmax*sin(0.5*theta)
        yaxpx = -ymax*sin(0.5*theta)
        yaxpy =  ymax*cos(0.5*theta)
        call sgslai(31)
        call sglau(-xaxpx, -xaxpy, xaxpx, xaxpy)
        call sgslai(41)
        call sglau(-yaxpx, -yaxpy, yaxpx, yaxpy)

        if(n .ne. 0) then
          call sgspli(81)
          call sgplu(n+1,  xi,  yi)
          call sgspli(91)
          call sgplu(n+1, xi0, yi0)
        end if

        call sgspmi(41)
        call sgspmt(5)
        call sgpmu(1, xi0(n), yi0(n))
        call sgspmt(10)
        call sgpmu(1, xi0(0), yi0(0))
        call sgspmi(21)
        call sgspmt(230)
        call sgpmu(1, xi(n), yi(n))
      end do

      call grcls

      end
***********************************************************************
      subroutine integ(f, x0, y0, u0, v0, t, x, y, xi, yi, xi0, yi0)

      theta = f*t
      x =   ( 1 - cos(theta) )*v0/f + u0*sin(theta)/f + x0
      y = - ( 1 - cos(theta) )*u0/f + v0*sin(theta)/f + y0
      xi  =  x*cos(0.5*theta) -  y*sin(0.5*theta)
      yi  =  x*sin(0.5*theta) +  y*cos(0.5*theta)
      xi0 = x0*cos(0.5*theta) - y0*sin(0.5*theta)
      yi0 = x0*sin(0.5*theta) + y0*cos(0.5*theta)

      return
      end
********************************************************************************
