********************************************************************************
* ɽ ϵήϳ ׻¸
*
*      3оʿձ Thorpe(1985)ήطǥ
*      3D graphics
*
*  99/07/02 ; 
********************************************************************************
      program graf3d

      implicit real*8(a-h,o-z)
      include 'incpa.f'
      dimension phi(-1:imax,-1:jmax)                     ! potential function
      integer    ij(-1:imax)                             ! ̥٥ֹ
      real v(0:imax-1,0:jmax-1),theta(0:imax-1,0:jmax-1) ! ս(ñ)
*-----+--1---------2---------3---------4---------5---------6---------7-+
* ǡɤ߹
      open (51,file='thorpe1.data', form='unformatted')
      read (51) ij, phi
      close(51)

* v, theta η׻
      call vtheta(phi, v, theta)

* ս(3D)
      call graph3(v, theta, ij)

      stop
      end
********************************************************************************
      subroutine vtheta(phi, v, theta)

      implicit real*8(a-h,o-z)
      include 'incpa.f'
      dimension phi(-1:imax,-1:jmax)                     ! potential function
      real v(0:imax-1,0:jmax-1),theta(0:imax-1,0:jmax-1) ! ս(ñ)
*-----+--1---------2---------3---------4---------5---------6---------7-+
* v, theta η׻
      do i=0,imax-1
        do j=0,jmax-1
          delr = phi(i+1,j  ) - phi(i-1,j  )
          delz = phi(i  ,j+1) - phi(i  ,j-1)

          if(i .eq. 0) then
            v(i,j) = 0.0
          else
            v(i,j) = delr*rn*h /(2d0*dr*sqrt( 1d0 + delr/(i*dr**2) ))
          end if
          theta(i,j) = delz/(2d0*dz) *theta0*rn**2 *h/g   + theta0
        end do
      end do

      return
      end
********************************************************************************
      subroutine graph3(v, theta, ij)

      include 'incpa.f'
      parameter(nxy=7,mxy=20)
      parameter(vxmin=-1.0,vxmax=1.0,vymin=-1.0,vymax=1.0)
      parameter(vzmin= 0.0,vzmax=1.0)
      parameter(xvp3=-2.5,yvp3=-5.0,zvp3=4.)
      parameter(xfc3=(vxmax+vxmin)/2,yfc3=(vymax+vymin)/2)
      parameter(zfc3=(vzmax+vzmin)/2)
      parameter(jdel=4)
ccc      parameter(ntone=18,ipat0=20,idlev=4) ! , ֹν, ʬ
ccc      parameter(ntone=35,ipat0=20,idlev=2) ! , ֹν, ʬ
      parameter(ntone=69,ipat0=21,idlev=1) ! , ֹν, ʬ
      parameter(ltr=30)

      real uu(-nxy:nxy,-nxy:nxy,0:jmax-1)
      real vv(-nxy:nxy,-nxy:nxy,0:jmax-1)
      real tt(-mxy:mxy,-mxy:mxy,0:jmax-1)
      real v(0:imax-1,0:jmax-1),theta(0:imax-1,0:jmax-1) ! ս(ñ)
      real rbar(ntone+1,2)                               ! 顼С
      real ijtr(-ltr:ltr,-ltr:ltr,0:jmax-1)
      integer     ij(-1:imax)                            ! ̥٥ֹ
*-----+--1---------2---------3---------4---------5---------6---------7-+
      call gllset('lmiss', .true.)
      call glrget('rmiss',  rmiss)
      call gliget('imiss',  imiss)
      xymax = (imax-1)*dr /sqrt(2.)      ! Ⱦκ r=r0=xmax
      xymax = xymax*rn*h/f0/1000.        ! [km]
      zmin = 0.0
      zmax = (jmax-1)*dz                ! ľκ z=h =ymax
      zmax = zmax*h/1000.               ! [km]

* åɥǡ:(u,v)
      vmax = max(abs(rmin(v,imax*jmax,1)), abs(rmax(v,imax*jmax,1)))
      dxy = xymax/nxy 
      do k=-nxy,nxy
        do l=-nxy,nxy
          x = k*dxy
          y = l*dxy
          r = sqrt(x**2 + y**2)
          alpha = atan2(y,x)
          do i=0,imax-2
            r1 =     i*dr*rn*h/f0/1000.    
            r2 = (i+1)*dr*rn*h/f0/1000.    
            if(r.gt.r1 .and. r.le.r2) then
              do j=0,jmax-1
                vr =     v(i,j) 
     +             + (    v(i+1,j)-    v(i,j))*(r-r1)/(r2-r1)
                uu(k,l,j) = - vr*sin(alpha)/vmax
                vv(k,l,j) =   vr*cos(alpha)/vmax
              end do
            end if
          end do
        end do
      end do
* åɥǡ:theta'
      dxy = xymax/mxy 
      do k=-mxy,mxy
        do l=-mxy,mxy
          x = k*dxy
          y = l*dxy
          r = sqrt(x**2 + y**2)
          do i=0,imax-2
            r1 =     i*dr*rn*h/f0/1000.    
            r2 = (i+1)*dr*rn*h/f0/1000.    
            if(r.gt.r1 .and. r.le.r2) then
              do j=0,jmax-1
                tt(k,l,j) =  theta(i,j)
     +                    + (theta(i+1,j)-theta(i,j))*(r-r1)/(r2-r1)
     +                    -  theta(imax-1,j)
              end do
            end if
          end do
        end do
      end do
      do j=0,jmax-1
        uu(0,0,j) = 0.0
        vv(0,0,j) = 0.0
        tt(0,0,j) = theta(0,j) - theta(imax-1,j)
      end do
* åɥǡ:tropopause
      call rset(ijtr, (2*ltr+1)*(2*ltr+1)*jmax, 1, imiss)
      dxy = xymax/ltr
      do k=-ltr,ltr
        do l=-ltr,ltr
          x = k*dxy
          y = l*dxy
          r = sqrt(x**2 + y**2)
          do i=0,imax-1
            r1 =     i*dr*rn*h/f0/1000.    
            r2 = (i+1)*dr*rn*h/f0/1000.    
            if(r.ge.r1 .and. r.lt.r2) then
              if((r-r1) .lt. (r2-r)) then
                jmin = ij(i)
              else
                jmin = ij(i+1)
              end if
              do j=jmin,jmax-1
                ijtr(k,l,j) = 1
              end do
            end if
          end do
        end do
      end do
  
* setup for uepack
      rgmax = rmax(tt, (2*mxy+1)*(2*mxy+1)*jmax, 1)
      rgmin = rmin(tt, (2*mxy+1)*(2*mxy+1)*jmax, 1)
      rgmin = rgnle(rgmin)
      rgmax = rgnge(rgmax)
      dlev = (rgmax-rgmin)/ntone
      
      do i=1,ntone
        ipat = (ipat0 + (i-1)*idlev)*1000 + 999
        tlev1 = rgmin + (i-1)*dlev
        tlev2 = tlev1 + dlev
        rbar(i,1) = tlev1
        rbar(i,2) = tlev1

        if(i .eq.     1) tlev1 = rmiss
        if(i .eq. ntone) tlev2 = rmiss
        call uestlv(tlev1, tlev2, ipat)
      end do
      rbar(ntone+1,1) = rbar(ntone,1) + dlev
      rbar(ntone+1,2) = rbar(ntone,1) + dlev

      dxma = (rgmax-rgmin)/2
      dxmi = dxma/2

* setup for dcl
      call swiset('iwidth', 720)
      call swiset('iheight',540)
      call sglset('lcorner', .false.)
      call sglset('lclip', .true.)
      call sglset('lfull', .true.)
      call udlset('lmsg', .false.)
      call uzfact(2.5)
      call gropn(1)

      call scseye(xvp3, yvp3, zvp3)
      call scsobj(xfc3, yfc3, zfc3)
      do j=0,jmax-1,jdel
        call grfrm
*-- x-z ʿ ----
        call grswnd(-xymax, xymax,  zmin,  zmax)
        call grsvpt( vxmin, vxmax, vzmin, vzmax)
        call grstrn(1)
        call grstrf

        call scspln(1, 3, vymax)
        call scsprj
        
        call uzlset('labelxb', .true.)
        call uzlset('labelyl', .true.)
        call uyaxdv('l', 1.0, 5.0)
        call uysttl('l', 'Z [km]', 0.)

        do jj=0,j,jdel
*-- x-y ʿ ----
          call grswnd(-xymax, xymax, -xymax, xymax)
          call grsvpt( vxmin, vxmax,  vymin, vymax)
          call grstrn(1)
          call grstrf

          vzlev = vzmin + (vzmax-vzmin)*jj/(jmax-1)
          call scspln(1, 2, vzlev)
          call scsprj

          call uetone(tt(-mxy,-mxy,jj), 2*mxy+1, 2*mxy+1, 2*mxy+1)

          call uzinit
          call uxaxdv('b', 1000., 5000.)
          call uxaxdv('t', 1000., 5000.)
          call uyaxdv('l', 1000., 5000.)
          call uyaxdv('r', 1000., 5000.)
          if(jj .eq. 0) then
            call uxsttl('b', 'X [km]', 0.)
            call uysttl('l', 'Y [km]', 0.)
          end if

cc          call ugiset('index', 91)
          call uglset('lnrmal', .false.)
          vfact = 0.1
          call ugrset('xfact1', vfact)
          call ugrset('yfact1', vfact)
          call uglset('lmsg', .false.)
          call ugvect(uu(-nxy,-nxy,jj), 2*nxy+1,
     +                vv(-nxy,-nxy,jj), 2*nxy+1, 2*nxy+1, 2*nxy+1)

          call sgspmi(991)
          call sgspmt(45)
          call sgspms(0.001)
          dxy = xymax/ltr
          do k=-ltr+1,ltr-1
            do l=-ltr+1,ltr-1
              x = k*dxy
              y = l*dxy
              if(ijtr(k,l,jj) .eq. 1) call sgpmu(1, x, y)
            end do
          end do

          call ugvect(uu(-nxy,-nxy,jj), 2*nxy+1,
     +                vv(-nxy,-nxy,jj), 2*nxy+1, 2*nxy+1, 2*nxy+1)

* - color bar
          if(jj .eq. 0) then
            call grfig
            call grsvpt(      0.0,             1.0, -1.5, -1.3)
            call grswnd(rbar(1,1), rbar(ntone+1,1),  0.0,  1.0)
            call grstrn(1)
            call grstrf

            call uetone(rbar, ntone+1, ntone+1, 2)
            call uxaxdv('b', dxmi, dxma) 
            call uzlset('labelxb', .false.)
            call uxaxdv('t', dxmi, dxma) 
            call uzlset('labelyl',.false.)
            call uyaxdv('l', 1., 1.) 
            call uyaxdv('r', 1., 1.) 
            call uzlset('labelyl', .false.)
          end if
        end do
      end do  

      call grcls
      end
********************************************************************************

