********************************************************************************
* ɽ ϵήϳ ׻¸
*
*      3оʿձ Thorpe(1985)ήطǥ
*      SORˡˤˡ
*
*  95/06/07  
*      97/08/31 ݸ ů
*      99/07/02 ; 
********************************************************************************
      program thorpe

      implicit real*8(a-h,o-z)
      include 'incpa.f'
      dimension phi(-1:imax,-1:jmax)                     ! potential function
      dimension thz0(-1:imax)                            !  at z=0
      dimension thzt(-1:imax)                            !  at tropopause
      dimension thzh(-1:imax)                            !  at z=h
      integer     ij(-1:imax)                            ! ̥٥ֹ
      real v(0:imax-1,0:jmax-1),theta(0:imax-1,0:jmax-1) ! ս(ñ)
      character cdummy*60
*-----+--1---------2---------3---------4---------5---------6---------7-+
* ¸ѥ᡼ɤ߹
      open (51,file='expar.data')
      read (51,*) thc, tht, r0, cdummy
      close(51)

      thc = thc / (theta0 * rn**2 * h/g)
      tht = tht / (theta0 * rn**2 * h/g)
      r0  = r0*1d3 / (rn*h/f0)

* 
      do i=-1,imax
        thz0(i) = thc / (1d0 + (i*dr/r0)**2)            !  at z=0
        thzt(i) = tht / (1d0 + (i*dr/r0)**2) + ht       !  at tropopause
        thzh(i) = ht + qs*(1d0 - ht)                    !  at z=h
      end do

* ˡ(SOR)
      call sor(phi, thz0, thzt, thzh, ij)

* ǡν
      open (61,file='thorpe1.data', form='unformatted')
      write(61) ij, phi
      close(61)

* v, theta η׻
      call vtheta(phi, v, theta)

* ս(ľ̿)
      call graph(v, theta, ij)

      stop
      end
********************************************************************************
*     SOR ˡ
********************************************************************************
      subroutine sor(phi, thz0, thzt, thzh, ij)

      implicit real*8(a-h,o-z)
      include 'incpa.f'
      dimension
     +       phi(-1:imax,-1:jmax),       ! potential function
     +         q(-1:imax,-1:jmax),       ! PV
     +     theta(-1:imax,-1:jmax),       ! ΰβ 
     +     thz0(-1:imax),                !  at z=0
     +     thzt(-1:imax),                !  at ή
     +     thzh(-1:imax),                !  at z=h
     +       ij(-1:imax)                 ! ̤б٥ֹ `j'
*-----+--1---------2---------3---------4---------5---------6---------7-+
* 
      beta = 1.6d0                       ! overrelaxation parameter (1<<2)
      eps  = 1.d-5                       ! ǤڤȽ
      nmax = 10000                       ! SORȿκ
      nnum = 1000                        ! ΥޥͿޤǤȿ

* ͤ
      jpaus = nint(ht/dz)                ! Ϳ̥٥ֹ `j'
      write(*,*) ' JPAUS= ', jpaus

      do i=-1,imax
        ij(i) = jpaus
        do j=-1,jpaus
          q(i,j) = qt                    ! ήPVͤ
        end do
        do j=jpaus+1,jmax
          q(i,j) = qs                    ! طPVͤ
        end do
      end do

      do i=-1,imax                             ! б٤0Ȥphi롧
        do j=-1,jpaus                          ! q = (phi)zz 
          phi(i,j) = qt*(j*dz)**2/2d0
        end do                                 ! ̤phiϢ³,
        do j=jpaus+1,jmax                      ! İ쳬ʬ()Ϣ³ 
          phi(i,j) = (qt-qs)*ht*(j*dz - ht/2d0)
     +                 + qs/2d0*(j*dz)**2
        end do                    ! i=imaxͤSORη֤Ф
      end do                      ! (r=r_max)ꤵ줿Ȥˤʤ

*-- SORȿ -----------------------------------
      do n=1,nmax
        pmax = 0d0                             ! «Ƚͤν
        ampn = dble(min(n,nnum))/dble(nnum)    ! ˥Υޥ

* ̤
        do i=0,imax-1
          thcrit = (thzt(i) - ht)*ampn + ht    ! ̤Ǥβ()
          do j=0,jmax-1
            delz = phi(i,j+1) - phi(i,j-1)
            theta(i,j) = delz/(2d0*dz)         ! ̤׻
            if(theta(i,j) .gt. thcrit) then
              ij(i) = j-1                      ! ̥٥ֹ `j'
              go to 99
            end if
          end do
   99     continue
        end do  

* ήطΤ줾PVͤͿ
        do i=0,imax-1
          do j=0,ij(i)
            q(i,j) = qt                        ! ήPVͤ
          end do
          do j=ij(i)+1,jmax-1
            q(i,j) = qs                        ! طPVͤ
          end do
        end do

* 롼(i,j) 
        do i=imax-1,0,-1
          do j=jmax-1,0,-1
            if(i .eq. 0) phi(-1,j) = phi(1,j)  ! (r=0): ư® v=0
            if(j .eq. 0) phi(i,-1) =
     +         phi(i,1) - 2d0*thz0(i)*ampn*dz  ! (z=0): d/dz=0
            if(j .eq. jmax-1) phi(i,jmax) =
     +         phi(i,jmax-1) + thzh(i)*dz      ! (z=1): d/dz=h

*           ˡ  n+1 ܤη׻
            delr  = phi(i+1,j  ) - phi(i-1,j  )
            delrr = phi(i+1,j  ) + phi(i-1,j  ) - 2d0*phi(i,j)
            delzz = phi(i  ,j+1) + phi(i  ,j-1) - 2d0*phi(i,j)

            if(i .eq. 0) then     ! r=0ξ: ðL'HopitalǤ魯
              a = 2d0*delrr/dr**2 + 1d0
              b =   a*delzz/dz**2 /q(i,j) - 1d0
              c =            a**2 /q(i,j)
              phi(i,j) = phi(i,j)
     +                 + beta*a*dr**2 *b/(2d0*c*(dr/dz)**2 + 2d0)
            else                  !"̾ξ
              e = ( ( 1d0 + delr/(i*dr**2) ) *dr/dz )**2 /q(i,j)
              p = delrr + e*delzz - 3d0*delr/(2d0*i) - dr**2
              phi(i,j) = phi(i,j) + beta*p/(2d0 + 2d0*e)
            endif

            if(dabs(p) .gt. pmax) pmax = dabs(p)   !'pnij' in Thorpe(1985)
          end do                                   !κͤõ
        end do

* «Ƚ
        if(mod(n,100) .eq. 0) write(*,*) 'N =',n,' residual =',pmax
        if(pmax .le. eps) then
          write(6,*) 'N =',n,' residual =',pmax,' < ',eps
          return
        endif   
      end do  
*-- SORȿ -----------------------------------

* «ʤ
      write(*,*) 'residual =',pmax,' > ',eps, ' => iteration stoped!!'
      stop
      end
********************************************************************************
      subroutine vtheta(phi, v, theta)

      implicit real*8(a-h,o-z)
      include 'incpa.f'
      dimension phi(-1:imax,-1:jmax)                     ! potential function
      real v(0:imax-1,0:jmax-1),theta(0:imax-1,0:jmax-1) ! ս(ñ)
*-----+--1---------2---------3---------4---------5---------6---------7-+
* v, theta η׻
      do i=0,imax-1
        do j=0,jmax-1
          delr = phi(i+1,j  ) - phi(i-1,j  )
          delz = phi(i  ,j+1) - phi(i  ,j-1)

          if(i .eq. 0) then
            v(i,j) = 0.0
          else
            v(i,j) = delr*rn*h /(2d0*dr*sqrt( 1d0 + delr/(i*dr**2) ))
          end if
          theta(i,j) = delz/(2d0*dz) *theta0*rn**2 *h/g   + theta0
        end do
      end do

      return
      end
********************************************************************************
      subroutine graph(v, theta, ij)

      include 'incpa.f'

      real v(0:imax-1,0:jmax-1),theta(0:imax-1,0:jmax-1) ! ս(ñ)
      real         x(-1:imax),z(-1:imax)
      integer     ij(-1:imax)                            ! ̥٥ֹ
      character csgi*1
*-----+--1---------2---------3---------4---------5---------6---------7-+
      xmin = 0.0
      zmin = 0.0
      xmax = (imax-1)*dr                ! Ⱦκ r=r0=xmax
      xmax = xmax*rn*h/f0/1000.         ! [km]
      zmax = (jmax-1)*dz                ! ľκ z=h =ymax
      zmax = zmax*h/1000.               ! [km]

      do i=0,imax-1
        x(i) = i*dr *rn*h/f0/1000.   
        z(i) = ij(i)*dz *h/1000.
      end do
      x(-1)   = x(0)
      z(-1)   = zmax
      x(imax) = x(imax-1)
      z(imax) = zmax

      call swiset('iwidth', 540)
      call swiset('iheight',540)
      call udlset('lmsg', .false.)
      call udsfmt('(i3)')

      call gropn(1)
      call grfrm
      call grswnd(xmin, xmax, zmin, zmax)
      call grsvpt(0.15, 0.95, 0.58, 0.93)
      call grstrn(1)
      call grstrf

      call sgstnp(9999)
      call sgtnu(imax+2, x, z)

      call uzlset('labelxb',.false.)
      call uxaxdv('b', 1000., 2000.)
      call uzlset('labelxb',.true.)
      call uxaxdv('t', 1000., 2000.)
      call uyaxdv('l', 1., 5.)
      call uyaxdv('r', 1., 5.)
      call uxmttl('t', 'v [m/s]', -0.7) 
      call uymttl('l', 'z [km]', 0.0) 
      call udiclv
      call udgclb(v, imax, imax, jmax, 1.)
      call udcntr(v, imax, imax, jmax)

      call grfig
      call grswnd(xmin, xmax, zmin, zmax )
      call grsvpt(0.15, 0.95, 0.12, 0.47 )
      call grstrn( 1 )
      call grstrf

      call sgstnp(9999)
      call sgtnu(imax+2, x, z)

      call uxaxdv('b', 1000., 2000.)
      call uxaxdv('t', 1000., 2000.)
      call uyaxdv('l', 1., 5. )
      call uyaxdv('r', 1., 5. )
      call uxmttl('t', csgi(135)//' [K]', -0.7) 
      call uymttl('l', 'z [km]', 0.0) 
      call uxmttl('b', 'r [km]', 0.0)
      call udiclv
      call udgclb(theta, imax, imax, jmax, 5.)
      call udcntr(theta, imax, imax, jmax)

      call grcls
      return
      end
********************************************************************************
