********************************************************************************
* ɽ ϵήϳ ׻¸
*
*     ϤΥʥߥ
*     2ܤαλȯŸ
*
*  97/09/05 ƣ ¹(ɺҸ 絤ҳ ˽ҳʬ M1)
*      99/04/28 ; 
********************************************************************************
      program uzuito3

      parameter(nmax=3,itmax=50000) ! nmax: θĿ, itmax:ʬƥå׿
      parameter(dt=5.0,istep=1)     ! dt: ֹ(=tend-t), istep: ƥå׿
      parameter(xmin=-70.,xmax=70.,ymin=-70.,ymax=70.)

      real z(2*nmax),work(2*nmax,3),gamma(nmax)
      real x(0:itmax,nmax),y(0:itmax,nmax)
      character cdummy*60

      common /const/gamma
      external odrkg, fcn
*-----+--1---------2---------3---------4---------5---------6---------7-+
* ¸ѥ᡼ɤ߹
      open(1,file='expar3.data') 
      read(1,*) gamma(1), x(0,1), y(0,1),   ! 1ν۴Ĥx,yɸ
     +          gamma(2), x(0,2), y(0,2),   ! 2ν۴Ĥx,yɸ
     +          gamma(3), x(0,3), y(0,3),   ! 3ν۴Ĥx,yɸ
     +          cdummy 
      close(1)

* 
      t    =   0.0
      z(1) = x(0,1)
      z(2) = y(0,1)
      z(3) = x(0,2)
      z(4) = y(0,2)
      z(5) = x(0,3)
      z(6) = y(0,3)

* ȯŸ
      do i=1,itmax
        tend =t + dt
        call odrkdu(2*nmax, odrkg, fcn, t, tend, istep, z, work)
        x(i,1) = z(1)
        y(i,1) = z(2)
        x(i,2) = z(3)
        y(i,2) = z(4)
        x(i,3) = z(5)
        y(i,3) = z(6)
      end do

* ׻̤βĻ벽
      call swiset('iwidth',  540)
      call swiset('iheight', 540)
c      call swlset('lalt',   .true.)
c      call swlset('lwait',  .false.)
      call sglset('lcorner',.false.)
      call gropn(1)

      call grfrm
      call grswnd(xmin, xmax, ymin, ymax)
      call grsvpt(0.15, 0.95, 0.10, 0.90)
      call grstrn(1)
      call grstrf

      call uxaxdv('b', 10., 50.)
      call uxaxdv('t', 10., 50.) 
      call uxsttl('b', 'X', 0.0)
      call uyaxdv('l', 10., 50.)
      call uyaxdv('r', 10., 50.) 
      call uysttl('l', 'Y', 0.0)

      do i=0,itmax
        call sgspmi(21)
        call sgpmu(1, x(i,1), y(i,1))
        call sgspmi(41)
        call sgpmu(1, x(i,2), y(i,2))
        call sgspmi(31)
        call sgpmu(1, x(i,3), y(i,3))
      end do

      call grcls

      stop
      end
********************************************************************************
      subroutine fcn(n,t,x,dx)

      parameter(nmax=3)
      parameter(pi=3.141592)

      real x(n),dx(n),gamma(nmax)

      common /const/gamma
*-----+--1---------2---------3---------4---------5---------6---------7-+
      dx(1) =   (0.5*gamma(2)/pi)*(x(4)-x(2))
     +                                / ((x(3)-x(1))**2+(x(4)-x(2))**2)
     +        + (0.5*gamma(3)/pi)*(x(6)-x(2))
     +                                / ((x(5)-x(1))**2+(x(6)-x(2))**2)
      dx(2) = - (0.5*gamma(2)/pi)*(x(3)-x(1))
     +                                / ((x(3)-x(1))**2+(x(4)-x(2))**2)
     +        - (0.5*gamma(3)/pi)*(x(5)-x(1))
     +                                / ((x(5)-x(1))**2+(x(6)-x(2))**2)
      dx(3) =   (0.5*gamma(3)/pi)*(x(6)-x(4))
     +                                / ((x(5)-x(3))**2+(x(6)-x(4))**2)
     +        + (0.5*gamma(1)/pi)*(x(2)-x(4))
     +                                / ((x(1)-x(3))**2+(x(2)-x(4))**2)
      dx(4) = - (0.5*gamma(3)/pi)*(x(5)-x(3))
     +                                / ((x(5)-x(3))**2+(x(6)-x(4))**2)
     +        - (0.5*gamma(1)/pi)*(x(1)-x(3))
     +                                / ((x(1)-x(3))**2+(x(2)-x(4))**2)
      dx(5) =   (0.5*gamma(1)/pi)*(x(2)-x(6))
     +                                / ((x(1)-x(5))**2+(x(2)-x(6))**2)
     +        + (0.5*gamma(2)/pi)*(x(4)-x(6))
     +                                / ((x(3)-x(5))**2+(x(4)-x(6))**2)
      dx(6) = - (0.5*gamma(1)/pi)*(x(1)-x(5))
     +                                / ((x(1)-x(5))**2+(x(2)-x(6))**2)
     +        - (0.5*gamma(2)/pi)*(x(3)-x(5))
     +                                / ((x(3)-x(5))**2+(x(4)-x(6))**2)

      return
      end
********************************************************************************
